  /*
  Вариант беспроводного соединения Устройства Управления с Исполнительным Устройством.
  Устройство Управления занимается только выводом информации на экран. Вся обработка импульсов
  производится ESP32-S2 mini, связанной с Исполнительным Устройством, передаётся по протоколу 
  ESP-NOW на ESP32-S2 mini Устройства Управления.
  */

  #include <SPI.h>                      // библиотека <SPI.h>
  #include <esp_now.h>
  #include <WiFi.h>
  #include <esp_wifi.h>
  #include <TFT_eSPI.h>                 // библиотека для работы с дисплеем
  TFT_eSPI tft = TFT_eSPI();            // вызов пользовательской библиотеки
  #include <Arduino.h>                  // библиотека Arduino
  #include "FS.h"
  #include <SD.h>                       // библиотека <SD.h> карты пвмяти

                   // Новый MAC Address этой платы
  uint8_t newMACAddress[] = {0xC8, 0xC9, 0xA3, 0x6A, 0xD9, 0x64};    
 
 	 // МАС-АДРЕС платы, на которую отправляем данные. 
  uint8_t broadcastAddress[] = {0x30, 0x83, 0x98, 0xB2, 0x6E, 0xAF};

  #define  TFT_GREY 0x5AEB              // New colour
  #define  CS_PIN          12           // вывод выбора карты памяти 
  #define  DI_Pin          34           // назначение вывода DI_Pin - ввод кнопок, данные
  #define  LC_Pin          17           // назначение вывода LC_Pin - загрузка кнопок
  #define  SP_Pin          15           // назначение вывода SP_Pin - загрузка/сдвиг
  #define  SCI_Pin         21           // назначение вывода SCI_Pin - синхроимпульсы
  #define  DO_Pin          36           // назначение вывода DO_Pin - вывод на индикацию, данные
  #define  SCO_Pin         40           // назначение вывода SCO_Pin - синхроимпульсы
  #define  WRO_Pin         38           // назначение вывода WRO_Pin - запись в выходной регистр
  #define  BAT_Pin         13           // назначение вывода BAT_Pin - напряжение батареи
 
  float  mlat = 0.0;                    // широта
  float  mlng = 0.0;                    // долгота
  float  malt = 0.0;                    // высота
  uint16_t mday = 0;                    // день
  uint16_t mmonth = 0;                  // месяц
  uint16_t myear = 0;                   // год
  uint16_t mhour = 0;                   // часы
  uint16_t mminute = 0;                 // минуты
  uint16_t msat = 0;                    // количество спутников

  int oscv;                             // указание верхней позиции y
  int oscn;                             // указание нижней позиции y
  int h;                                // высота квадрата на дисплее
  int v=100;                            // указание счётчика строк v (начальное значение 100)
  int x = 0;                            // указатель текущего значения предельного расстояния
  float m;                              // указание расстояния в метрах m
  float mauto;                          // указание расстояния в метрах mauto
  float mn;                             // указание предельного расстояния mn
  float md;                             // указание текущего расстояния в метрах md
  float mnA;                            // указание предельного расстояния mnA
  float mnB;                            // указание предельного расстояния mnB
  float mnC;                            // указание предельного расстояния mnC
  float mnd;                            // указание предельного расстояния mnd
  float mndauto;                        // указание предельного расстояния mndauto
  float vmn;                            // указание коэффициента по вертикали vmn = f(mn) 
  float Cornerx;                        // указание угла отклонения по оси x 
  float Direction;                      // направления по компасу 
  float Pressure;                       // атмосферное давление
  float Altitude;                       // высота над уровнем моря 
  const float Pi = 3.14159;
  int dispm;                            // указание предыдущей конечной координаты dispm
  int disp;                             // указание координаты нижней точки по вертикали disp
  int dispp;                            // указание координаты верхней точки по вертикали dispp
  float voltage1 = 0.0;                 // объявление переменной voltage1 
  uint16_t kolfile = 0;       	        // количество файлов в каталоге 
  uint16_t namefile = 0;                // имя текущего файла 
  uint16_t numzap = 0;                  // имя записываемого файла 
  uint16_t numkat = 0;                  // имя каталога
  uint16_t maxfile = 0;                 // имя последнего записываемого файла 
  uint16_t maxkat = 0;                  // имя последнего каталога
  uint16_t duration;                    // объявление переменной длительности сигнала от приёмника
  float cm;                             // объявление переменной cm (расстояние в см)
  uint16_t durmax;                      // объявление переменной durmax - максимальное время
  String katnum = "/"+String(numkat);   
  String fildname = "/"+String(numkat)+"/"+String(namefile)+".txt";   
  String datmas;   

  float voltage = 0.0;                  // объявление переменной voltage
  float analog = 0.0;                   // объявление переменной analog
  float analog1 = 0.0;                  // объявление переменной analog1
  uint8_t regkn = 0xFF;                 // рабочий регистр
  uint8_t regkn1 = 0xFF;                // регистр чтения кнопок управления исполнительным устройством 
  uint8_t regkn2 = 0xFF;                // регистр чтения кнопок управления каналами
  uint8_t regm1 = 0xC6;                 // регистр хранения режима управления исполнительным устройством
  uint8_t regm2 = 0x3C;                 // регистр храннения режима управления каналами
  uint8_t reg_IN = 0xFD;                // регистр бита индикации
  uint8_t reg_kn1 = 0xFF;               // рабочий регистр кнопок 1
  uint8_t reg_kn2 = 0xFF;               // рабочий регистр кнопок 2
  uint8_t reg_ind1 = 0x6F;              // рабочий регистр индикации 1
  uint8_t reg_ind2 = 0xF7;              // рабочий регистр индикации 2
  uint8_t regch = 0x3A;                 // регистр обмена данными

  #define LOG_SIZE 10                   // размер лога (LOG_SIZE ячеек)
  #define CHN_SIZE 4                    // размер лога (CHN_SIZE массивов каналов)
  #define KUS_SIZE 3                    // размер лога (KUS_SIZE массивов коэф. усиления)
  #define IMP_SIZE 3                    // размер лога (IMP_SIZE массивов длительности импульса)
  #define GEO_SIZE 11                   // размер лога (GEO_SIZE массива геоданных)
  #define DATE_SIZE 7                   // размер лога (DATE_SIZE массива записываемых на SD данных)
  uint16_t durus[CHN_SIZE][LOG_SIZE+12];    // массив измерений. Для текущего времени в момент изменения
  uint16_t durout[CHN_SIZE][LOG_SIZE+12];   // массив измерений. Для выдачи на дисплей
  uint16_t arrey1[CHN_SIZE][LOG_SIZE+12];   // массив измерений. Для принимаемых данных
  uint16_t durusauto[IMP_SIZE][KUS_SIZE][CHN_SIZE][LOG_SIZE+12];    // массив измерений  
  uint16_t durusread[IMP_SIZE][KUS_SIZE][CHN_SIZE][LOG_SIZE+12];    // массив измерений  
  float mnair[7] = {0.2, 0.5, 1, 2, 4, 8, 20};
  float vmnair[7] = {4.5, 9, 18, 37, 73, 146, 370};
  float mngraund[7] = {1, 2, 5, 10, 20, 40, 80};
  float vmngraund[7] = {4, 10.5, 21, 42, 83, 167, 333};
  float geo[GEO_SIZE];                     // массив измерений. Для геоданных
  float geosum[GEO_SIZE];                  // массив измерений. Сумма геоданных
  float geodate[DATE_SIZE];                // массив измерений. Геоданные
  float georead[DATE_SIZE];                // массив измерений. Геоданные с карты памяти

  long int crdread;                       // Время старта
  uint32_t start;                       // Время старта
  uint32_t now;                         // Текущее машинное время в мкс
  uint32_t prevUs;                      // Предыдущее время изменения состояния пина
  uint32_t ekrnow;                      // Текущее машинное время в мкс
  uint32_t ekrpush;                     // время нажатия кнопки Экран
  uint32_t delnow;                      // Текущее машинное время в мкс
  uint32_t delpush;                     // время нажатия кнопок 0 и 1
  uint32_t delfilenow;                  // Текущее машинное время в мкс
  uint32_t delfilepush;                 // время нажатия кнопок 0 и 2 
  uint32_t delkatnow;                   // Текущее машинное время в мкс
  uint32_t delkatpush;                  // время нажатия кнопки 2
  uint32_t dispnow;                     // Текущее машинное время в мкс
  uint32_t disppush;                    // время нажатия кнопки 4
  uint32_t newkatnow;                   // Текущее машинное время в мкс
  uint32_t newkatpush;                  // время нажатия кнопки 3 и 5
  uint32_t decrnow;                     // Текущее машинное время в мкс
  uint32_t decrpush;                    // время нажатия кнопки 3
  uint32_t mndecrnow;                   // Текущее машинное время в мкс
  uint32_t mndecrpush;                  // время нажатия кнопок 3 и 4
  uint32_t incrnow;                     // Текущее машинное время в мкс
  uint32_t incrpush;                    // время нажатия кнопки 5
  uint32_t mnincrnow;                   // Текущее машинное время в мкс
  uint32_t mnincrpush;                  // время нажатия кнопок 4 и 5
  int IND_BIT;                          // бИТ индикации текущего канала
  uint16_t count = 0;                   // Счётчик циклов измерения
  bool first,prevS,flag,flerr = 0;      // Первое, предыдущее состояние пина, флаг не первого измерения, флаг ошибки
  bool flagn = 0;                       // если 1, то канал в этом цикле прочитан
  bool airgnd;                          // 0 - пин на земле, 1 - висит в воздухе
  bool djmp;                            // бит переключателя DC
  bool zap = 0;                         // флаг режима записи (кнопка Экран)
  bool ekran;                           // флаг нажатия кнопки Экран
  bool screen;                          // флаг режима чтения каналов
  bool autonom = 0;                     // флаг автономного режима 
  bool delfileknt,delfileknp,delfilefl = 0;   // предыдущее, текущее состояние кнопок 0 и 2
  bool delknt,delknp,delfl = 0;               // предыдущее, текущее состояние кнопки, флаг нажатия кнопок 0 и 1
  bool delkatknt,delkatknp,delkatfl = 0;      // предыдущее, текущее состояние кнопки, флаг нажатия кнопки 2
  bool dispknt,dispknp,dispfl = 0;            // предыдущее, текущее состояние кнопки, флаг нажатия кнопки 4
  bool decrknt,decrknp,decrfl = 0;            // предыдущее, текущее состояние кнопки, флаг нажатия кнопки 3
  bool mndecrknt,mndecrknp,mndecrfl = 0;      // предыдущее, текущее состояние кнопки, флаг нажатия кноп0к 3 и 4
  bool incrknt,incrknp,incrfl = 0;            // предыдущее, текущее состояние кнопки, флаг нажатия кнопки 5
  bool mnincrknt,mnincrknp,mnincrfl = 0;      // предыдущее, текущее состояние кнопки, флаг нажатия кнопок 4 и 5
  bool newkatknt,newkatknp,newkatfl=0;        // предыдущее, текущее состояние, флаг нажатия кнопок 3 и 5
  bool flpush = 0;                      // флаг нажатия
  bool fluzap = 0;                      // флаг коэффициента усиления перед записью
  bool nocard = 0;                      // флаг отсутствия карты памяти
  bool readAUTO = 0;                    // флаг чтения из карты памяти всех каналов
  bool oscknp, oscknt, osc = 0;	        // предыдущее, текущее состояние кнопки, флаг режима осциллографа
  bool zapknp, zapknt, zapisy = 0;      // предыдущее, текущее состояние кнопки, флаг процесса записи на карту памяти
  bool readknp,readknt,reading = 0;     // предыдущее, текущее состояние кнопки, флаг режима чтения из карты памяти всех каналов 
  bool readknpA,readkntA,readingA = 0;  // предыдущее, текущее состояние кнопки, флаг чтения из карты памяти канала A
  bool readknpB,readkntB,readingB = 0;  // предыдущее, текущее состояние кнопки, флаг чтения из карты памяти канала B
  bool readknpC,readkntC,readingC = 0;  // предыдущее, текущее состояние кнопки, флаг чтения из карты памяти канала C
  bool readknpD,readkntD,readingD = 0;  // предыдущее, текущее состояние кнопки, флаг чтения из карты памяти канала D
  bool firstloop = 1;                   // первый вход в loop()
  bool qryzap = 0;                      // запрос записи на карту памяти
  volatile bool flagrec = 0;            // флаг подтверждения приёма данных
  volatile bool flagsend = 0;           // флаг подтверждения отправки данных на ISP
  volatile bool flagrequ = 0;           // флаг запроса отправки данных на ISP
  int k = 0;                            // Указатель текущего канала для чтения
  uint16_t c = 0;                       // Указатель текущего номера канала    
  uint16_t u = 0;                       // Указатель текущего коэффициента усиления
  uint16_t uzap = 0;                    // Указатель коэффициента усиления перед записью
  uint16_t p = 0;                       // Указатель длительности пачки импульсов
  uint16_t pzap = 0;                    // Указатель длительности импульса перед записью
  uint16_t g = 0;                       // Указатель номера файла
  File myFile;
  File root;
  int f = 0;                            // создаём переменную-итератор
  char Bytes[32];                       // создаём переменную для хранения байтов в формате char,
  String Bytec;                         // создаём переменную для хранения байтов в формате char,
  char floatbuf[32];

 			// Вводим переменные для хранения отправляемых данных по WiFi
  uint8_t regout = 0x3A;                // регистр выдачи на исполнительное устройство

  			// Вводим переменные для хранения принимаемых данных по WiFi
  uint8_t incomingRegin;                // регистр обмена данными
  float incomingVoltbat;
  uint16_t incomingArrey1[CHN_SIZE][LOG_SIZE+12];
  float incomingArrey2[GEO_SIZE];                 // массив измерений. Для геоданных

  			// Переменная для хранения состояния отправки
  String success;
 
                // структура для отправляемых данных
        // (Должна совпадать со структурой передачи на плате-приемнике)
  typedef struct struct_sendmes {
  uint8_t reg1;
  } struct_sendmes;

                 // структуры для принимаемых данных по WiFi
          // (Должна совпадать со структурой на плате-приемнике)
  typedef struct struct_recmes {
  uint8_t regin;                          // регистр обмена данными
  float voltbat;                          // напряжение батареи
  uint16_t arrey1[CHN_SIZE][LOG_SIZE+12]; // массив измерений. текущее время в момент изменения
  float arrey2[GEO_SIZE];                 // массив измерений. Для геоданных
  } struct_recmes;

          // Создаем переменную для хранения отправляемого сообщения
  struct_sendmes UPRReadings;
 
  			  // То же, но для принимаемого сообщения
  struct_recmes incomingReadings;
 
  			  // Callback-функция для получения состояния отправки на ISP
  esp_now_peer_info_t peerInfo; 

  void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) {
  // Serial.print("\r\nLast Packet Send Status:\t");
  // Serial.println(status == ESP_NOW_SEND_SUCCESS ? "Delivery Success" : "Delivery Fail");
  if (status ==0){
  flagsend = 1;                           // установка флага отправки данных на ISP  
  flagrec = 0;
  success = "Delivery Success :)";
  } else {
  success = "Delivery Fail :(";
  }
  }

  		    // То же, для получения состояния приема данных от ISP
  void OnDataRecv(const uint8_t * mac, const uint8_t *incomingData, int len) {
  memcpy(&incomingReadings, incomingData, sizeof(incomingReadings));
  // Serial.print("Bytes received: ");
  // Serial.println(len);

		      // приём данных
  regch = incomingReadings.regin;                // регистр обмена данными
  voltage1 = incomingReadings.voltbat;
  for (int l = 0; l < CHN_SIZE; l++) {    // перебираем каналы
  for (int i = 0; i < LOG_SIZE+12; i++) {
  durus[l][i] = incomingReadings.arrey1[l][i];
  durout[l][i] = incomingReadings.arrey1[l][i];
  } }
  for (int k = 0; k < GEO_SIZE; k++) {     // перебираем 
  geo[k] = incomingReadings.arrey2[k];
  }
  if (zapisy == 1 ) {                    // Если установлен процесс записи, 
  if (p == 0 & u == 0) {                 // если p = 0 и u = o
  for (int k = 0; k < GEO_SIZE; k++) {   // перебираем 
  geosum[k] = 0;                         // обнуляем
  } 
  }
  for (int k = 0; k < GEO_SIZE - 3; k++) {   // перебираем 
  geosum[k] = geosum[k] + geo[k];            // суммируем данные
  }
  if (p == 2 & u == 2) {                     // если p = 2 и u = 2
  for (int k = 0; k < GEO_SIZE - 3; k++) {   // перебираем 
  geosum[k] = geosum[k]/9;                   // усредняем
  }
  Cornerx = atan2(geosum[1],geosum[2])*180/Pi;
  Direction = atan2(geosum[3],geosum[4])*180/Pi;
  Pressure = geosum[6];                   // атмосферное давление
  Altitude = geosum[7];                   // высота над уровнем моря 
  mlat = geo[8];                          // широта 
  mlng = geo[9];                          // долгота
  malt = geo[10];                         // высота над уровнем моря
  geodate[0] = Cornerx;                   // угол наклона по оси x в градусах
  geodate[1] = Direction;                 // направление на север в градусах
  geodate[2] = Pressure;                  // атмосферное давление в паскалях
  geodate[3] = Altitude;                  // высота над уровнем моря в метрах
  geodate[4] = mlat;                      // широта в градусах
  geodate[5] = mlng;                      // долгота в градусах
  geodate[6] = malt;                      // высота над уровнем моря в метрах

  } 
  }
  duration = durout[c][LOG_SIZE];
  count = durout[c][LOG_SIZE+1];
  if (reading == 0 ) {                    // если не установлен процесс чтения всего массива
  if (zap == 1 ) {                        // Если установлен режим записи, 
  if (bitRead(regch,6) == 1) {            // Если включён процесс записи на карту памяти, то 
  qryzap = 1;                             // устанавливаем флаг записи на карту памяти
  bitClear(regch, 6);                     // запись нуля в 6 разряд 
  } } 
  flagrec = 1;                            // устанавливаем в 1 флаг приёма данных
  flagsend = 0;
  } }

  void createDir(fs::FS &fs, const char * path){
    // Serial.printf("Creating Dir: %s\n", path);
    if(fs.mkdir(path)){
        // Serial.println("Dir created");
    } else {
        // Serial.println("mkdir failed");
    }
  }

  void removeDir(fs::FS &fs, const char * path){
    // Serial.printf("Removing Dir: %s\n", path);
    if(fs.rmdir(path)){
        // Serial.println("Dir removed");
    } else {
        // Serial.println("rmdir failed");
    }
  }

  void deleteFile(fs::FS &fs, const char * path){
    // Serial.printf("Deleting file: %s\n", path);
    if(fs.remove(path)){
        // Serial.println("File deleted");
    } else {
        // Serial.println("Delete failed");
    }
  }

  void setup() {    

  pinMode(DI_Pin, INPUT);                         // назначение вывода DI_Pin входом 
  pinMode(BAT_Pin, INPUT);		          // назначение вывода BAT_Pin входом

  pinMode(LC_Pin, OUTPUT);		          // назначение вывода LC_Pin выходом 
  pinMode(SP_Pin, OUTPUT);		          // назначение вывода SP_Pin выходом
  pinMode(SCI_Pin, OUTPUT);		          // назначение вывода SCI_Pin выходом
  pinMode(DO_Pin, OUTPUT);		          // назначение вывода DO_Pin выходом
  pinMode(SCO_Pin, OUTPUT);		          // назначение вывода SCO_Pin выходом
  pinMode(WRO_Pin, OUTPUT);		          // назначение вывода WRO_Pin выходом
 
  		        // запись начального состояния индикации 

  reg_ind1 = 0x6F;                                // начальное состояние в регистр индикации 1
  reg_ind2 = 0xF7;                                // начальное состояние в регистр индикации 2
  write_ind();                                    // запись индикации

   Serial.begin(115200);                           // открываем серийный порт для дебаггинга 
  // while(!Serial);                              // Ждём соединения с последовательном портом (необходимо для совместимости с Arduino Leonardo)
  // delay (5000);

 		            // Выставляем режим работы Wi-Fi
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  WiFi.setTxPower(WIFI_POWER_MINUS_1dBm);         // Установка минимального уровня мощности WiFi

                // Устанавливаем новый MAC Address этой платы 
  esp_wifi_set_mac(WIFI_IF_STA, &newMACAddress[0]);
 
  			       // Инициализируем протокол ESP-NOW
 
  if (esp_now_init() != ESP_OK) {
  // Serial.println("Error initializing ESP-NOW");
  return;
  }
  		  // Регистрируем callback-функцию для получения статуса отправки на ISP
  esp_now_register_send_cb(OnDataSent);
 
  			       // Регистрируем пиры
  memcpy(peerInfo.peer_addr, broadcastAddress, 6);
  peerInfo.channel = 0;  
  peerInfo.encrypt = false;

  			       // Добавляем пиры

  if (esp_now_add_peer(&peerInfo) != ESP_OK){
  // Serial.println("Failed to add peer");
  return;
  }
 
  		   // Регистрируем callback-функцию для получения статуса приема от ISP
  esp_now_register_recv_cb(OnDataRecv);

  tft.init();                                 // инициализациz TFT-экрана
  tft.setRotation(1);                         // альбомное расположение экрана

  tft.fillScreen(TFT_BLACK);                  // очистка экрана, цвет чёрный
  tft.setTextColor(TFT_YELLOW,TFT_BLACK);     // жёлтый шрифт на чёрном фоне

  // Serial.print("Initializing SD card...");    // "Инициализация SD-карты..."
  if (!SD.begin(CS_PIN)) {
  // Serial.println("initialization failed!");   // "инициализация не удалась!"
  nocard = 1;                                 // флаг отсутствия карты памяти
  return;
  }
  // Serial.println("initialization done.");     // "инициализация выполнена."
  }                                           // завершение setup


  void loop() {

  if (firstloop == 1 ) {                      // если первый вход в loop()
  read_kn();                                  // чтение кнопок
  autonom = !bitRead(reg_kn2, 7);             // проверка состояния кнопки "Чтение"
  if (autonom == 1 )  {                       // если установлен процесс чтения всего массива
  zap = 1;                                    // включение режима записи
  reading = 1;                                // включение режима чтения 
  findemaxkat(SD);                            // определяем имя последнего каталога
  numkat = maxkat;                            // текущее имя = имя последнего каталога
  findemaxfile(SD);                           // определяем имя последнего файла
  namefile = maxfile;                         // текущее имя = имя последнего файла
  }  
  firstloop = 0;                              // сброс флага первого входа в loop()
  impuls();                                   // обработка кнопок
  findkanal();
  } 

  if (autonom == 1 ) {                        // если установлен процесс чтения всего массива
  zap = 1 ;                                   // включение режима записи
  reading = 1;                                // включение режима чтения 
  } 

		// Записываем переменные для отправки на ISP
  if (reading == 1 ) {                     // если установлен процесс чтения всего массива
  flagrequ = 1;                               // установка флага отправки данных
  flagrec = 0;                                // сброс флага приёма данных от ISP
  impuls();                                   // обработка кнопок
  } 
  if (flagrequ == 0 && flagsend == 0 ) {      // Если ещё не было пересылки на ISP
  impuls();                                   // обработка кнопок
  findkanal();
  UPRReadings.reg1 = regout;
  
  // printSendDate();
		       // Отправляем сообщение на ISP
  esp_now_send(broadcastAddress, (uint8_t *) &UPRReadings, sizeof(UPRReadings));
  flagrequ = 1;
  } 

                       // приём данных и запись их в массив
                     //durusauto[KUS_SIZE=u][CHN_SIZE=l][LOG_SIZE+12]
                    //за четыре прохода при различных l = номер канала

  if(flagrec == 1){                           // ожидание приёма от ISP
  delay (10);
   printIncomingReadings();
  if (bitRead(reg_IN, 5) == 0) {              // проверяем пятый бит если 0 - AUTO
  for (int l = 0; l < CHN_SIZE; l++) {        // перебираем каналы
  for (int i = 0; i < LOG_SIZE+12; i++) {
  durusauto[p][u][l][i] = durus[l][i]; } }    // переписываем принятый массив в durusauto[p][u]
  flagrec = 0;                                // сброс флага приёма данных от ISP

                       // формирование файла для записи на карту памяти массива
                   // durusauto[IMP_SIZE][KUS_SIZE=u][CHN_SIZE=l][LOG_SIZE+12]
               // три раза по три прохода при различных p = длительность импульса
                      // при различных u = козффициент усиления

  if (zap == 1 ) {                            // Если установлен режим записи, 
  if (zapisy == 1 ) {                         // Если установлен процесс записи, 
  if (u < 2) {                                // если коэффициент не 36 - увеличиваем
  u = u + 1;                                  // увеличиваем козффициент усиления 
  flagrequ = 0;                               // сброс флага отправки на ISP
  impuls();                                   // обработка кнопок
  } else                                      // если коэффициент 36
  if (p < 2) {                                // если длительность импульса меньше 16, 
  p = p + 1;                                  // увеличиваем длительность импульса 
  u = 0;                                      // козффициент усиления 1
  flagrequ = 0;                               // сброс флага отправки на ISP
  impuls();                                   // обработка кнопок
  } else {                                    // если длительность импульса 16
  p = pzap;                                   // восстанавливаем длительность импульса перед записью 
  u = uzap;                                   // восстанавливаем коэффициент усиления перед записью 
  fluzap = 1;                                 // установка флага записи
  if (namefile == 0 ) {                       // Если нулевой файл, 
  findemaxfile(SD);                           // определяем имя последнего файла
  namefile = maxfile;                         // текущее имя = имя последнего файла
  }
  zapisy = 0 ;                                // сброс флага процесса записи
  bitClear(regout, 6);                        // запись нуля в 6 разряд 
  flagrequ = 0;                               // сброс флага отправки на ISP
  printIncom();
  // Serial.println("Запись на карту "); 
  namefile = numzap;
  maxfile = namefile;
  // Serial.print("namefile = "); 
  // Serial.println(namefile);
  writeArrey(SD);                             // запись файла на карту памяти
  numzap = namefile + 1;
  impuls();                                   // обработка кнопок
  } }                                         // Если не установлен процесс записи, сразу идём сюда
  }                                           // Если не установлен режим записи, сразу идём сюда
  flagrequ = 0;                               // сброс флага отправки на ISP
  DispOut();                                  // вывод  на дисплей
  } else {                                    // если режим не AUTO
  flagrequ = 0;                               // сброс флага отправки на ISP
  DispOut(); }                                // вывод  на дисплей
  }                                           // флага приёма от ISP нет

         // чтение всех файлов в каталоге карты памяти в память Ардуино 
                           // и вывод их на дисплей

  if (reading == 1 ) {                        // если установлен процесс чтения всего массива
  CardReading ();                             // чтение массива из карты памяти 
  DispOut();
  }
  }                                           // завершение loop

      // Функция чтения массива из карты памяти и отправки на дисплей

  void CardReading () {
 
  // Serial.println("void CardReading ");  
  if ((!readAUTO && !readingA && !readingB && !readingC && !readingD) == 0 ) {   // если установлен хотя бы один флаг чтения 
  // Serial.println("Чтение карты ");  
  tft.fillScreen(TFT_BLACK);                  // очистка экрана, цвет чёрный
  tft.setTextColor(TFT_YELLOW,TFT_BLACK);     // жёлтый шрифт на чёрном фоне
  for (g = 0; g < maxfile ; g++) {            // перебор файлов на карте памяти
  namefile = g;                               // имя текущего файла 
  readArrey(SD);                              // чтение одного файла с карты памяти
  v = 100 + g;
  printArrey();
  if(screen == 0 ) {                          // если прошли последний файл
  for (int p = 0; p < IMP_SIZE; p++) {        // перебираем длительность импульса
  for (int u = 0; u < KUS_SIZE; u++) {        // перебираем коэффициент усиления
  OutReading();                               // вывод на дисплей 
  } } } else {   
  usildef();                                  // определение коэффициента усиления
  OutReading();                               // вывод на дисплей 
  } } } }                                     // завершение CardReading ()

      // Запись одного файла на карту памяти в память Ардуино
      // Массив содержит измерения расстояний для четырёх каналов 
      // при трёх вариантах коэффициента усиления. Всего 12 измерений.

  void writeArrey(fs::FS &fs){    

  String fildname = "/"+String(numkat)+"/"+String(namefile)+".txt";   
  File myFile = fs.open(fildname.c_str(), FILE_WRITE);   
  if(myFile){                                 // если файл доступен (открыт для записи), то ...
  // Serial.printf("Открыт файл: %s\n", fildname.c_str());
  for (int p = 0; p < IMP_SIZE; p++) {        // перебираем длительность импульса
  for (int u = 0; u < KUS_SIZE; u++) {        // перебираем коэффициент усиления
  for (int l = 0; l < CHN_SIZE; l++) {        // перебираем каналы
  for (int i = 0; i < LOG_SIZE+12; i++) {
  myFile.println(durusauto[p][u][l][i]);      // записываем массив на карту памяти
  } } } }
  for (int k = 0; k < DATE_SIZE; k++) {       // перебираем 
  myFile.println(geodate[k]);                     // записываем массив на карту памяти
  }
  myFile.flush();                             // закрываем файл
  myFile.close();                             // закрываем файл
  } }                                         // завершение writeArrey()    

          // Функция для чтения одного файла с карты памяти в память ESP32 в массив durusread[h][i][j].

  void readArrey(fs::FS &fs){ 
  // Serial.println("Чтение с карты");        // Выводим текст в последовательный порт.
  String fildname = "/"+String(numkat)+"/"+String(namefile)+".txt";   
  File myFile = fs.open(fildname.c_str());
  // Serial.printf("Открыт файл: %s\n", fildname.c_str());
  while(myFile.available()) {
  for (int p = 0; p < IMP_SIZE; p++) {        // перебираем длительность импульса
  for (int u = 0; u < KUS_SIZE; u++) {        // перебираем коэффициент усиления
  for (int l = 0; l < CHN_SIZE; l++) {        // перебираем каналы
  for (int i = 0; i < LOG_SIZE+12; i++) {
  while(myFile.available()&&                  // пока файл не закончился,
  ((Bytes[f] = myFile.read()) != '\n')) ++f;  // читаем байты дальше до следующего символа новой строки,
  crdread = atoi(Bytes);                      // конвертируем в int,
  durusread[p][u][l][i] = crdread & 0xFFFF;    // конвертируем в int,
  f = 0;                                   // сбрасываем итератор,
  } } } } 
  for (int k = 0; k < DATE_SIZE; k++) {    // перебираем 
  while(myFile.available()&&               // пока файл не закончился,
  ((Bytes[f] = myFile.read()) != '\n')) ++f;   // читаем байты дальше до следующего символа новой строки,
  georead[k] = atof(Bytes);                // конвертируем в float,
  f = 0;                                    // сбрасываем итератор,
  }
  myFile.close();                             // закрываем файл
  } }                                          // завершение readArrey()  

          // Функция для вывода на монитор данных, отправляемых Ардуино на WeMos, связанную с Исполнительным Устройством.

  void printSendDate(){
 
       // Отображаем показания в мониторе порта
 
  Serial.println("ПЕРЕДАЧА НА ISP ");
  Serial.print("regout = "); 
  Serial.println(regout, BIN);
  Serial.println(" ");
  }

          // Функция для вывода на монитор данных, принимаемых Ардуино от WeMos, связанной с Исполнительным Устройством.

  void printIncomingReadings(){
  
  Serial.println("ПРИЁМ_ОТ_ISP ");
  Serial.print("regch: ");
  Serial.println(regch, BIN);
  Serial.print("voltage1: ");
  Serial.println(voltage1);
  for (int l = 0; l < CHN_SIZE; l++) {        // перебираем каналы
  Serial.print("Канал "); 
  Serial.println(l);
  Serial.println("durus: ");
  for (int i = 0; i < LOG_SIZE; i++) {        // перебираем импульсы
  Serial.println(durus[l][i]); 
  }
  Serial.print("duration "); 
  Serial.println(durus[l][LOG_SIZE]);
  
  Serial.print("count "); 
  Serial.println(durus[l][LOG_SIZE+1]);

  Serial.print("Канал "); 
  Serial.println(durus[l][LOG_SIZE+2]);

  Serial.print("Усиление "); 
  Serial.println(durus[l][LOG_SIZE+3]);

  Serial.print("Импульсов "); 
  Serial.println(durus[l][LOG_SIZE+4]);
  Serial.println();
 
  Serial.print("Позиция "); 
  Serial.println( durus[l][LOG_SIZE+5]);

  Serial.print("День "); 
  Serial.println( durus[l][LOG_SIZE+6]);

  Serial.print("Месяц "); 
  Serial.println( durus[l][LOG_SIZE+7]);

  Serial.print("Год "); 
  Serial.println( durus[l][LOG_SIZE+8]);

  Serial.print("Часы "); 
  Serial.println( durus[l][LOG_SIZE+9]);

  Serial.print("Минуты "); 
  Serial.println( durus[l][LOG_SIZE+10]);

  Serial.print("Спутников "); 
  Serial.println( durus[l][LOG_SIZE+11]);
  Serial.println();
 } 

  Serial.print("AccelX = "); 
  Serial.println(geo[0]);

  Serial.print("AccelY = "); 
  Serial.println(geo[1]);

  Serial.print("AccelZ = "); 
  Serial.println(geo[2]);

  Serial.print("MagX = "); 
  Serial.println(geo[3]);

  Serial.print("MagY = "); 
  Serial.println(geo[4]);

  Serial.print("MagZ = "); 
  Serial.println(geo[5]);

  Serial.print("Pressure = "); 
  Serial.println(geo[6]);

  Serial.print("Altitude = "); 
  Serial.println(geo[7]);

  Serial.print("Широта = "); 
  Serial.println(geo[8]);

  Serial.print("Долгота = "); 
  Serial.println(geo[9]);

  Serial.print("Высота = "); 
  Serial.println(geo[10]);
  Serial.println();

  Serial.print("AccelX = "); 
  Serial.println(geosum[0]);

  Serial.print("AccelY = "); 
  Serial.println(geosum[1]);

  Serial.print("AccelZ = "); 
  Serial.println(geosum[2]);

  Serial.print("MagX = "); 
  Serial.println(geosum[3]);

  Serial.print("MagY = "); 
  Serial.println(geosum[4]);

  Serial.print("MagZ = "); 
  Serial.println(geosum[5]);

  Serial.print("Pressure = "); 
  Serial.println(geosum[6]);

  Serial.print("Altitude = "); 
  Serial.println(geosum[7]);
  Serial.println();

  Serial.print("Cornerx = "); 
  Serial.println(geodate[0]);

  Serial.print("Direction = "); 
  Serial.println(geodate[1]);

  Serial.print("Pressure = "); 
  Serial.println(geodate[2]);

  Serial.print("Altitude = "); 
  Serial.println(geodate[3]);

  Serial.print("Широта = "); 
  Serial.println(geodate[4]);

  Serial.print("Долгота = "); 
  Serial.println(geodate[5]);

  Serial.print("Высота = "); 
  Serial.println(geodate[6]);
  Serial.println();

  Serial.println("Массив прочитан");
  Serial.println();
  } 

          // Функция для вывода на монитор массива данных, записанных с карты памяти.

  void printArrey(){
  
  Serial.println("Прочитанный массив ");

  for (int p = 0; p < IMP_SIZE; p++) {        // перебираем длительность импульса
  for (int u = 0; u < KUS_SIZE; u++) {
  for (int l = 0; l < CHN_SIZE; l++) {
  Serial.println();
  Serial.print("Усиление: ");
  Serial.println(u);
  Serial.print("Канал "); 
  Serial.println(l);
  Serial.print("Импульсов "); 
  Serial.println(p);
  Serial.println("durus: ");
  for (int i = 0; i < LOG_SIZE; i++) {
  Serial.println( durusread[p][u][l][i]);
  }
  Serial.print("duration "); 
  Serial.println( durusread[p][u][l][LOG_SIZE]);
  
  Serial.print("count "); 
  Serial.println( durusread[p][u][l][LOG_SIZE+1]);

  Serial.print("Канал "); 
  Serial.println( durusread[p][u][l][LOG_SIZE+2]);

  Serial.print("Усиление "); 
  Serial.println( durusread[p][u][l][LOG_SIZE+3]);
 
  Serial.print("Импульсов "); 
  Serial.println( durusread[p][u][l][LOG_SIZE+4]);

  Serial.print("Позиция "); 
  Serial.println( durusread[p][u][l][LOG_SIZE+5]);
  Serial.println(); 
  } } }
 Serial.print("Cornerx = "); 
  Serial.println(georead[0]);

  Serial.print("Direction = "); 
  Serial.println(georead[1]);

  Serial.print("Pressure = "); 
  Serial.println(georead[2]);

  Serial.print("Altitude = "); 
  Serial.println(georead[3]);

  Serial.println("Массив прочитан");
  Serial.println(" ");
  } 

  void printIncom(){
  
  Serial.println("Принятый массив ");

  for (int p = 0; p < IMP_SIZE; p++) {        // перебираем длительность импульса
  for (int u = 0; u < KUS_SIZE; u++) {
  for (int l = 0; l < CHN_SIZE; l++) {
  Serial.print("Усиление: ");
  Serial.println(u);
  Serial.print("Канал "); 
  Serial.println(l);
  Serial.print("Импульсов "); 
  Serial.println(p);
  Serial.println("durus: ");
  for (int i = 0; i < LOG_SIZE; i++) {
  Serial.println( durusauto[p][u][l][i]);
  }
  Serial.print("duration "); 
  Serial.println( durusauto[p][u][l][LOG_SIZE]);
  
  Serial.print("count "); 
  Serial.println( durusauto[p][u][l][LOG_SIZE+1]);

  Serial.print("Канал "); 
  Serial.println( durusauto[p][u][l][LOG_SIZE+2]);

  Serial.print("Усиление "); 
  Serial.println( durusauto[p][u][l][LOG_SIZE+3]);

  Serial.print("Импульсов "); 
  Serial.println(durusauto[p][u][l][LOG_SIZE+4]);

  Serial.print("Позиция "); 
  Serial.println(durusauto[p][u][l][LOG_SIZE+5]);
  Serial.println(" ");
 
  } } }
  Serial.print("Cornerx = "); 
  Serial.println(geodate[0]);

  Serial.print("Direction = "); 
  Serial.println(geodate[1]);

  Serial.print("Pressure = "); 
  Serial.println(geodate[2]);

  Serial.print("Altitude = "); 
  Serial.println(geodate[3]);

  Serial.println();
  Serial.println("Массив прочитан ");
  Serial.println();
  } 
  
          // Функция для определения расстояния до точки отражения и предела шкалы на дисплее. 

  void countcm() {
  
  read_kn();                                                    // чтение кнопок
  airgnd = bitRead(reg_kn1, 0);                                 // Читаем текущее состояние кнопоки воздух / вода 
  if (airgnd == 1){                                             // Если 1, то воздух
  cm = duration / 58;                                           // Вычисление расстояния до объекта в воздухе в см и запись его в регистр 
  
  if (cm <= 20) {(mn = 0.2); (vmn = 4.5);}                      // если расстояние меньше или равно 20, записываем 0.2 в mn
  else if  (cm > 20 && cm <= 50) {(mn = 0.5); (vmn = 9);}       // если расстояние больше 20, но меньше или равно 50, записываем 0.5 в mn
  else if  (cm > 50 && cm <= 100) {(mn = 1); (vmn = 18);}       // если расстояние больше 50, но меньше или равно 100, записываем 1 в mn
  else if  (cm > 100 && cm <= 200) {(mn = 2); (vmn = 37);}      // если расстояние больше 100, но меньше или равно 200, записываем 2 в mn
  else if  (cm > 200 && cm <= 400) {(mn = 4); (vmn = 73);}      // если расстояние больше 200, но меньше или равно 400, записываем 4 в mn
  else if  (cm > 400 && cm <= 800) {(mn = 8); (vmn = 146);}     // если расстояние больше 400, но меньше или равно 800, записываем 8 в mn
  else if  (cm > 800 && cm <= 2000) {(mn = 20); (vmn = 370);}   // если расстояние больше 800, но меньше или равно 2000, записываем 20 в mn
  m=(float)cm/100.0;                                            // Запись в регистр m расстояния, делённого на 100 (перевод в метры)    

  } else {                                                      // Если не 1, то вода
  cm = duration / 13;                                           // Вычисление расстояния до объекта в воде и запись его в регистр 

  if (cm <= 100) {(mn = 1); (vmn = 4.2);}                       // если расстояние меньше или равно 100, записываем 1 в mn
  else if  (cm > 100 && cm <= 200) {(mn = 2); (vmn = 10.5);}    // если расстояние больше 500, но меньше или равно 1200, записываем 2 в mn
  else if  (cm > 200 && cm <= 500) {(mn = 5); (vmn = 21);}      // если расстояние больше 1000, но меньше или равно 500, записываем 5 в mn
  else if  (cm > 500 && cm <= 1000) {(mn = 10); (vmn = 42);}    // если расстояние больше 500, но меньше или равно 1000, записываем 10 в mn
  else if  (cm > 1000 && cm <= 2000) {(mn = 20); (vmn = 83);}   // если расстояние больше 1000, но меньше или равно 2000, записываем 20 в mn
  else if  (cm > 2000 && cm <= 4000) {(mn = 40); (vmn = 167);}  // если расстояние больше 2000, но меньше или равно 4000, записываем 40 в mn
  else if  (cm > 4000 && cm <= 8000) {(mn = 80); (vmn = 333);}  // если расстояние больше 4000, но меньше или равно 8000, записываем 80 в mn
  m=(float)cm/100.0;                                            // запись в регистр m расстояния, делённого на 100 (перевод в метры)   
  } }

          // Функция для перебора каналов в режиме Auto при выводе на дисплей

  void OutReading() {
  
  if (readAUTO == 1){                   // если установлен процесс чтения всего массива из карты памяти
  bitClear(reg_ind2, 7);                // запись нуля в reg_ind2, 7 - включение FUTO
  bitClear(reg_ind2, 6);                // запись нуля в reg_ind2, 6 - включение L1
  write_ind() ;                         // запись индикации
  c = 0;                                // Устанавливаем  канал D
  reg_IN = 0xCF;                        // устанавливаем бит канала D
  IND_BIT = 0;                          // Устанавливаем бит индикации содержимого канала D
  DispOut ();                           // вывод  на дисплей
  bitSet(reg_ind2, 6);                  // запись 1 в reg_ind2, 6 - выключение L1
  bitSet(reg_ind1, 0);                  // гашение индикации канала D 
  bitClear(reg_ind2, 5);                // запись нуля в reg_ind2, 5 - включение L2
  write_ind();                          // запись индикации
  c = 1;                                // Устанавливаем следующий канал C
  reg_IN = 0xD7;                        // устанавливаем бит канала C
  IND_BIT = 1;                          // Устанавливаем бит индикации канала C
  DispOut ();                           // вывод  на дисплей
  bitSet(reg_ind2, 5);                  // запись 1 в reg_ind2, 5 - выключение L2
  bitSet(reg_ind1, 1);                  // гашение индикации канала C 
  bitClear(reg_ind2, 4);                // запись нуля в reg_ind2, 4 - включение L3
  write_ind();                          // запись индикации
  c = 2;                                // Устанавливаем следующий канал B
  reg_IN = 0xDB;                        // устанавливаем бит канала B
  IND_BIT = 2;                          // Устанавливаем бит индикации канала B
  DispOut ();                           // вывод  на дисплей
  bitSet(reg_ind2, 4);                  // запись 1 в reg_ind2, 4 - выключение L3
  bitSet(reg_ind1, 2);                  // гашение индикации канала B 
  bitClear(reg_ind2, 3);                // запись нуля в reg_ind2, 3 - включение L4
  write_ind();                          // запись индикации
  c = 3;                                // Устанавливаем следующий канал A
  reg_IN = 0xDD;                        // устанавливаем бит канала A
  IND_BIT = 3;                          // Устанавливаем бит индикации канала A
  DispOut ();                           // вывод  на дисплей
  bitSet(reg_ind2, 3);                  // запись 1 в reg_ind2, 3 - выключение L4
  bitSet(reg_ind1, 3);                  // гашение индикации канала A 
  write_ind();                          // запись индикации
  } else {                              // если не установлен процесс чтения всего массива
  bitSet(reg_ind2, 7);                  // запись 1 в reg_ind2, 7 - выключение AUTO
  if (readingD == 1 ){                  // если установлен процесс чтения канала D
  c = 0;                                // Устанавливаем  канал D
  bitClear(reg_ind2, 6);                // запись нуля в reg_ind2, 6 - включение L1
  write_ind();                          // запись индикации
  reg_IN = 0xCF;                        // устанавливаем регистр канала D
  IND_BIT = 0;                          // Устанавливаем бит индикации содержимого канала D
  DispOut ();                           // вывод  на дисплей
  bitSet(reg_ind2, 6);                  // запись 1 в reg_ind2, 6 - выключение L1
  bitSet(reg_ind1, 0);                  // гашение индикации канала D 
  write_ind(); }                        // запись индикации
  if (readingC == 1 ) {                 // если установлен процесс чтения канала C
  c = 1;                                // Устанавливаем следующий канал
  bitClear(reg_ind2, 5);                // запись нуля в reg_ind2, 5 - включение L2
  write_ind();                          // запись индикации
  reg_IN = 0xD7;                        // устанавливаем бит канала C
  IND_BIT = 1;                          // Устанавливаем бит индикации содержимого канала C
  DispOut ();                           // вывод  на дисплей
  bitSet(reg_ind2, 5);                  // запись 1 в reg_ind2, 5 - выключение L2
  bitSet(reg_ind1, 1);                  // гашение индикации канала C 
  write_ind();  }                       // запись индикации
  if (readingB == 1 ) {                 // если установлен процесс чтения канала B
  c = 2;                                // Устанавливаем следующий канал
  bitClear(reg_ind2, 4);                // запись нуля в reg_ind2, 4 - включение L3
  write_ind();                          // запись индикации
  reg_IN = 0xDB;                        // устанавливаем бит канала B
  IND_BIT = 2;                          // Устанавливаем бит индикации содержимого канала B
  DispOut ();                           // вывод  на дисплей
  bitSet(reg_ind2, 4);                  // запись 1 в reg_ind2, 4 - выключение L3
  bitSet(reg_ind1, 2);                  // гашение индикации канала B 
  write_ind();   }                      // запись индикации
  if (readingA == 1 ) {                 // если установлен процесс чтения канала A
  c = 3;                                // Устанавливаем следующий канал
  bitClear(reg_ind2, 3);                // запись нуля в reg_ind2, 3 - включение L4
  write_ind();                          // запись индикации
  reg_IN = 0xDD;                        // устанавливаем бит канала A
  IND_BIT = 3;                          // Устанавливаем бит индикации содержимого канала A
  DispOut ();                           // вывод  на дисплей
  bitSet(reg_ind2, 3);                  // запись 1 в reg_ind2, 3 - выключение L4
  bitSet(reg_ind1, 3);                  // гашение индикации канала A 
  write_ind();  }                       // запись индикации
  } }                                   // завершение OutReading() 

  void DispOut() {        // Вывод информации на дисплей.

  analog = analogRead(BAT_Pin);               // читаем напряжение батареи 
  voltage = (analog*20.9) / 4095;             // пересчитываем число в вольты 
  countcm();                                  // вызов функции для определения расстояния

  if (bitRead(reg_IN, 5) == 0) {              // проверяем пятый бит если 0 - AUTO
  if (reading == 0 ){
                // определяем максимальную длительность последнего импульса
  
  durmax = max(durusauto[p][u][0][LOG_SIZE],durusauto[p][u][1][LOG_SIZE]);  // сравниваем каналы 0 и 1
  durmax = max(durmax,durusauto[p][u][2][LOG_SIZE]);                        // сравниваем максимум с каналом 2
  durmax = max(durmax,durusauto[p][u][3][LOG_SIZE]);                        // сравниваем максимум с каналом 3

  duration = durmax;                          // выбираем максимально удалённую точку
  countcm();                                  // вызов функции для определения расстояния до неё
  mndauto = mn;                               // указание предельного расстояния 
  mauto = m;                                  // указание расстояния в метрах до точки
  }
  if (reading == 1 ){                         // если установлен процесс чтения всего массива
  duration  = durusread[p][u][c][LOG_SIZE];      // читаем duration текущей точки
  countcm();                                  // вызов функции для определения расстояния до неё
  if (airgnd == 1){                           // если воздух
  mn = mnair[x];                              // находим предельное расстояние для воздуха
  vmn = vmnair[x];                            // находим коэффициент расстояния для воздуха
  } else {                                    // если грунт 
  mn = mngraund[x];                           // находим предельное расстояние для грунта
  vmn = vmngraund[x]; }                       // находим коэффициент расстояния для грунта
  mndauto = mn;                               // указание предельного расстояния для режима AUTO 
  mnd = mndauto;                              // назначение предела измерений
  mauto = m;                                  // указание расстояния в метрах для режима AUTO
   if (c == 3){                               // если текущий канал A
  mnA = mndauto; }                            // указание предельного расстояния mnA
  else if (c == 2){                           // если текущий канал B
  mnB = mndauto; }                            // указание предельного расстояния mnB
  else if (c == 1){                           // если текущий канал C
  mnC = mndauto; }                            // указание предельного расстояния mnC
  else if (c == 0){                           // если текущий канал D
  mnd = mndauto; }                            // указание предельного расстояния mnd
  md = mauto;                                 // назначение расстояния
  if (duration != 0) {                        // если duration не раВно нулю
  bitClear(reg_ind1, IND_BIT);                // Включаем светодиод текущего канала
  write_ind(); } 
  for (int i = 0; i < LOG_SIZE; i++) {        // перебираем массив 
  durout[c][i] = durusread[p][u][c][i]; }     // переписываем принятый массив в durus[l] durusread
  duration  = durusread[p][u][c][LOG_SIZE];   // читаем duration
  count  = durusread[p][u][c][LOG_SIZE+1];    // читаем count
  OutDisp(); 
  } else {                                    // если не установлен процесс чтения всего массива, сразу идём сюда
  for (int S = 0; S < CHN_SIZE; S++) {        // перебираем каналы
  c = S;
   for (int i = 0; i < LOG_SIZE; i++) {       // перебираем массив 
  durout[c][i]  = durusauto[p][u][c][i]; }    // переписываем принятый массив в durus[l] 
  duration  = durusauto[p][u][c][LOG_SIZE];   // читаем duration
  count  = durusauto[p][u][c][LOG_SIZE+1];    // читаем count
  countcm();                                  // вызов функции для определения расстояния до неё
   if (c == 3){                               // если текущий канал A
  mnA = mndauto; }                            // указание предельного расстояния mnA
  else if (c == 2){                           // если текущий канал B
  mnB = mndauto; }                            // указание предельного расстояния mnB
  else if (c == 1){                           // если текущий канал C
  mnC = mndauto; }                            // указание предельного расстояния mnC
  else if (c == 0){                           // если текущий канал D
  mnd = mndauto; }                            // указание предельного расстояния mnd
  md = mauto;                                 // назначение расстояния
  if (duration != 0) {                        // если duration не раВно нулю
  bitClear(reg_ind1, IND_BIT);                // Включаем светодиод текущего канала
  write_ind(); }                              // запись индикации		    
  OutDisp(); 
  } }                                         // если не установлен процесс чтения всего массива
  }  else {                                   // если НЕ AUTO, сразу попадаем сюда
  md = m;                                     // указание расстояния в метрах до точки md
  mnd = mn;                                   // указание предельного расстояния mnd
  if (duration != 0) {                        // если duration не раВно нулю
  bitClear(reg_ind1, IND_BIT);                // Включаем светодиод текущего канала
  write_ind(); }                              // запись индикации		    
  OutDisp(); 
  } } 
  
   void OutDisp() {  			      // Вывод на дисплей

  tft.setTextColor(TFT_YELLOW,TFT_BLACK);     // жёлтый шрифт на чёрном фоне  
  tft.setTextSize(2);                         // множитель размера текста
  tft.setCursor(0,0,4);                       // установка курсора на указанные позиции
  if (md < 10 ) {                             // если расстояние меньше 10 м
  {tft.print(md,2); }                         // вывод расстояния с двумя знаками после запятой   
  } else {                                    // если установлен флаг режима чтения 
  {tft.print(md,1); } }                       // вывод расстояния с одним знаком после запятой
  tft.fillRect(0,278,99,50,TFT_BLACK);	      // запись на экран чёрного квадрата
  tft.setCursor(8,280,4);                     // установка курсора на указанные позиции
  if (mnd < 1) {                              // если предел расстояния меньше 1 м,
  {tft.print(mnd,1); }                        // вывод предела с одним знаком после запятой
  } else {                                    // если больше 1 м, 
  {tft.print(mnd,0); } }                      // вывод предела целым числом
  tft.drawLine(0,160,100,160,TFT_YELLOW );    // вывод на экран средней линии

  if (zap == 1 ) {                            // если установлен режим записи, 
  if (reading == 1 ) {                        // если установлен режим чтения 
  if (screen == 0 ) {                         // если не установлен флаг режима чтения 
  tft.fillRect(0,156,100,7,TFT_GREEN);        // запись на экран зелёного квадрата   
  } else {                                    // если установлен флаг режима чтения 
  tft.fillRect(0,156,100,7,TFT_BLUE); }       // запись на экран синего квадрата   
  } else {                                    // если не установлен режим чтения   
  tft.fillRect(0,156,100,7,TFT_RED); }        // запись на экран красного квадрата   
  } else {                                    // если не установлен режим записи 
  tft.fillRect(0,156,100,7,TFT_BLACK);        // запись на экран чёрного квадрата
  tft.drawLine(0,160,100,160,TFT_YELLOW); }   // вывод на экран средней линии
  
  tft.drawLine(100,0,100,320,TFT_YELLOW);     // вывод на экран вертикальной линии)
  tft.setCursor(0,103,4);     	              // установка курсора на указанные позиции
  if (voltage >= 7){                          // если напряжение больше или равно 7 В
  tft.setTextColor(TFT_GREEN,TFT_BLACK);      // зелёный шрифт на чёрном фоне     
  tft.println(voltage,1);                     // вывод на экран напряжения зелёным цветом
  }else {                                     // иначе - выводим красным цветом
  tft.setTextColor(TFT_RED,TFT_BLACK);        // красный шрифт на чёрном фоне
  tft.println(voltage,1);}                    // вывод на экран напряжения красным цветом
  tft.setCursor(0,170,4);                     // установка курсора на указанные позиции
  if (voltage1 >= 10.5){                      // если напряжение больше или равно 10.5 В
  tft.setTextColor(TFT_GREEN,TFT_BLACK);      // зелёный шрифт на чёрном фоне     
  tft.println(voltage1,1);                    // вывод на экран напряжения зелёным цветом
  }else {                                     // иначе - выводим красным цветом
  tft.setTextColor(TFT_RED,TFT_BLACK);        // красный шрифт на чёрном фоне
  tft.println(voltage1,1); }                  // вывод на экран напряжения красным цветом
  tft.fillRect(0,50,99,50,TFT_BLACK);         // запись на экран чёрного квадрата
  tft.fillRect(0,225,99,50,TFT_BLACK);        // запись на экран чёрного квадрата

  if (zap == 1 ) {                            // Если установлен режим записи, 
  tft.setTextColor(TFT_WHITE,TFT_BLACK);      // белый шрифт на чёрном фоне  
  tft.setCursor(0,50,4);                      // установка курсора на указанные позиции
  {tft.print(numkat); }                       // вывод на экран имени каталока
  {tft.print("/"); }                          // вывод на экран черты каталока
  tft.setCursor(0,225,4);                     // установка курсора на указанные позиции
  {tft.print("/"); }                          // вывод на экран черты каталока
  if (kolfile == 0) {                         // если файлов больше нет,
  {tft.print("0"); }                          // вывод на экран 0
  } else {                                    // если файлы есть, 
  if (reading == 0 ){                         // если не установлен процесс чтения всего массива
  {tft.print(maxfile); }                      // вывод на экран количества файлов
  } else {                                    // если установлен процесс чтения всего массива
  if ((!readAUTO && !readingA && !readingB && !readingC && !readingD) == 0 ) {   // если установлен хотя бы один флаг чтения 
  {tft.print(g + 1); }                        // вывод на экран номера выводимого файла
  }  else {                                   // если не установлен хотя бы один флаг чтения 
  {tft.print(maxfile + 1); } } } }            // вывод на экран количества файлов
  } 

                               // вывод графика  
  if (osc == 1){                              // если включён осциллограф
  tft.drawLine(100,240,460,240,TFT_YELLOW );  // вывод на экран нижней линии отсечки осциллограммы
  if (bitRead(reg_IN, 5) == 1) {              // проверяем пятый бит, если 1 - SEPAR
  tft.fillRect(101,242,460,78,TFT_BLACK); }   // запись на экран чёрного квадрата под осциллограммы
  vmn = vmn*1.3;                              // укорачиваем вертикальную выдачу в 1,3 раза
  }                                           // если не включён осциллограф, сразу идём сюда
  for (int j = 0; j <= count;) {              // перебираем массив durus[j]

                           // вывод первого импульса
  if (j == 0){                                // если это первая запись в массиве

  disp = durout[c][j]/vmn;                    // нормируем вертикальную выдачу 
  dispp = disp +2;                            // задаём высоту точки в 2 пикселя

  if (c == 3){                                // если текущий канал A
  if (bitRead(reg_IN, 5) == 0) {              // проверяем пятый бит если 0 - AUTO
  disp = disp*mnA/mndauto;                    // нормируем вертикальную выдачу по каналу D
  dispp = disp +2; }                          // задаём высоту точки в 2 пикселя
  tft.drawLine(v,disp,v,dispp,TFT_MAGENTA);   // вывод на экран точки (2 пикселя) графика содержимого регистра (dispp)
  }                                           // если канал не A, сразу попадаем сюда
  if (c == 2){                                // если текущий канал B
  if (bitRead(reg_IN, 5) == 0) {              // проверяем пятый бит если 0 - AUTO
  disp = disp*mnB/mndauto;                    // нормируем вертикальную выдачу по каналу D
  dispp = disp +2; }                          // задаём высоту точки в 2 пикселя
  tft.drawLine(v,disp,v,dispp,TFT_ORANGE);    // вывод на экран точки (2 пикселя) содержимого регистра (dispp)
  }                                           // если канал не B, сразу попадаем сюда
  if (c == 1){                                // если текущий канал C
  if (bitRead(reg_IN, 5) == 0) {              // проверяем пятый бит если 0 - AUTO
  disp = disp*mnC/mndauto;                    // нормируем вертикальную выдачу по каналу D
  dispp = disp +2; }                          // задаём высоту точки в 2 пикселя
  tft.drawLine(v,disp,v,dispp,TFT_DARKGREEN); // вывод на экран точки (2 пикселя) содержимого регистра (dispp)
  }                                           // если канал не C, сразу попадаем сюда 
  if (c == 0){                                // если текущий канал D
  if (bitRead(reg_IN, 5) == 0) {              // проверяем пятый бит если 0 - AUTO
  disp = disp*mnd/mndauto;                    // нормируем вертикальную выдачу по каналу D
  dispp = disp +2; }                          // задаём высоту точки в 2 пикселя
  tft.drawLine(v,disp,v,dispp,TFT_DARKCYAN);  // вывод на экран точки (2 пикселя) содержимого регистра (dispp)
  }                                           // если все каналы просмотрели, попадаем сюда      

                              // вывод осциллограмы первого импульса
  if (osc == 1){   				    // если включён осциллограф
  disp = disp*1.5 + 101;                            // переводим вертикальный масштаб в горизонтальный (360 / 240)
  dispp = dispp*1.5 + 101;                          // переводим вертикальный масштаб в горизонтальный (360 / 240)
  oscv = 243;                                       // указание верхней позиции y (на 3 ниже черты)
  oscn = 317;                                       // указание нижней позиции y (на 3 выше нижнего края)
  h = 77;                                           // высота чёрного прямоугольника
  if (c == 3){                                      // если текущий канал A
  if (bitRead(reg_IN, 5) == 0) {                    // проверяем пятый бит 0 - AUTO, 
  oscv = 243;                                       // указание верхней позиции y
  oscn = 260;                                       // указание нижней позиции y      
  h = 18;                                           // высота чёрного прямоугольника
  tft.fillRect(101,241,460,22,TFT_BLACK); }         // запись на экран чёрного квадрата под графиком канала A
  tft.drawLine(101,oscn,disp,oscn,TFT_RED);         // вывод на экран нуля первого импульса
  tft.drawLine(disp,oscv,disp,oscn,TFT_RED);        // вывод на экран фронта первого импульса
  tft.drawLine(disp,oscv,dispp,oscv,TFT_RED);       // вывод на экран полочки первого импульса
  tft.drawLine(dispp,oscv,dispp,oscn,TFT_RED);      // вывод на экран спада первого импульса
  if (count == 1) {                                 // если счётчик равен 1
  tft.drawLine(dispp,oscn,460,oscn,TFT_RED); }      // вывод на экран нулевой линии до конца
  if (count == 0) {                                 // если счётчик равен 0
  tft.fillRect(101,oscv,460,h,TFT_BLACK);           // запись на экран чёрного квадрата под графиком канала A
  tft.drawLine(101,oscn,460,oscn,TFT_RED); }        // вывод на экран нулевой линии до конца
  } else                                            // если канал не A, сразу попадаем сюда   
  if (c == 2){                                      // если текущий канал B
  oscv = 263;                                       // указание верхней позиции y
  if (bitRead(reg_IN, 5) == 0) {                    // проверяем пятый бит 0 - AUTO, 
  oscv = 263;                                       // указание верхней позиции y
  oscn = 280;                                       // указание нижней позиции y      
  h = 18;                                           // высота чёрного прямоугольника
  tft.fillRect(101,oscv,460,20,TFT_BLACK); }        // запись на экран чёрного квадрата под график B
  tft.drawLine(101,oscn,disp,oscn,TFT_YELLOW);      // вывод на экран нуля первого импульса
  tft.drawLine(disp,oscv,disp,oscn,TFT_YELLOW);     // вывод на экран фронта первого импульса
  tft.drawLine(disp,oscv,dispp,oscv,TFT_YELLOW);    // вывод на экран полочки первого импульса
  tft.drawLine(dispp,oscv,dispp,oscn,TFT_YELLOW);   // вывод на экран спада первого импульса
  if (count == 1) {                                 // если счётчик равен 1
  tft.drawLine(dispp,oscn,460,oscn,TFT_YELLOW); }   // вывод на экран нулевой линии до конца
  if (count == 0) {                                 // если счётчик равен 0
  tft.fillRect(101,oscv,460,h,TFT_BLACK);           // запись на экран чёрного квадрата под график B
  tft.drawLine(101,oscn,460,oscn,TFT_YELLOW); }     // вывод на экран нулевой линии до конца
  } else                                            // если канал не B, сразу попадаем сюда   
  if (c == 1){                                      // если текущий канал C
  oscv = 283;                                       // указание верхней позиции y
  if (bitRead(reg_IN, 5) == 0) {                    // проверяем пятый бит 0 - AUTO, 
  oscv = 283;                                       // указание верхней позиции y
  oscn = 300;                                       // указание нижней позиции y      
  h = 18;                                           // высота чёрного прямоугольника
  tft.fillRect(101,oscv,460,20,TFT_BLACK); }        // запись на экран чёрного квадрата под график C
  tft.drawLine(101,oscn,disp,oscn,TFT_GREEN);       // вывод на экран нуля первого импульса
  tft.drawLine(disp,oscv,disp,oscn,TFT_GREEN);      // вывод на экран фронта первого импульса
  tft.drawLine(disp,oscv,dispp,oscv,TFT_GREEN);     // вывод на экран полочки первого импульса
  tft.drawLine(dispp,oscv,dispp,oscn,TFT_GREEN);    // вывод на экран спада первого импульса
  if (count == 1) {                                 // если счётчик равен 1
  tft.drawLine(dispp,oscn,460,oscn,TFT_GREEN); }    // вывод на экран нулевой линии до конца
  if (count == 0) {                                 // если счётчик равен 0
  tft.fillRect(101,oscv,460,h,TFT_BLACK);           // запись на экран чёрного квадрата под график C
  tft.drawLine(101,oscn,460,oscn,TFT_GREEN); }      // вывод на экран нулевой линии до конца
  } else                                            // если канал не C, сразу попадаем сюда
  if (c == 0){                                      // если текущий канал D
  oscv = 303;                                       // указание верхней позиции y
  if (bitRead(reg_IN, 5) == 0) {                    // проверяем пятый бит 0 - AUTO, 
  oscv = 303;                                       // указание верхней позиции y
  oscn = 317;                                       // указание нижней позиции y      
  h = 18;                                           // высота чёрного прямоугольника
  tft.fillRect(101,oscv,460,20,TFT_BLACK); }        // запись на экран чёрного квадрата под график D
  tft.drawLine(101,oscn,disp,oscn,TFT_CYAN);        // вывод на экран нуля первого импульса
  tft.drawLine(disp,oscv,disp,oscn,TFT_CYAN);       // вывод на экран фронта первого импульса
  tft.drawLine(disp,oscv,dispp,oscv,TFT_CYAN);      // вывод на экран полочки первого импульса
  tft.drawLine(dispp,oscv,dispp,oscn,TFT_CYAN);     // вывод на экран спада первого импульса
  if (count == 1) {                                 // если счётчик равен 1
  tft.drawLine(dispp,oscn,460,oscn,TFT_CYAN); }     // вывод на экран нулевой линии до конца
  if (count == 0) {                                 // если счётчик равен 0
  tft.fillRect(101,oscv,460,h,TFT_BLACK);           // запись на экран чёрного квадрата под график D
  tft.drawLine(101,oscn,460,oscn,TFT_CYAN); }       // вывод на экран нулевой линии до конца
  }                                                 // если все каналы просмотрели, попадаем сюда 
  dispm = dispp;                                    // запоминаем предыдущую конечную точку графика
  }                                                 // если осциллограф не включён, сразу попадаем сюда
  j = j+2;                                          // первую координату обработали, переходим к следующей координате
  } else                                            // если это не первая запись в массиве, сразу попадаем сюда    
  {                         // обработка остальных импульсов

  disp = durout[c][j]/vmn;	                        // нормируем вертикальную выдачу
  dispp = disp +2;                                  // задаём высоту точки в 2 пикселя
  if (c == 3){                                      // если текущий канал A
  if (bitRead(reg_IN, 5) == 0) {                    // проверяем пятый бит если 0 - AUTO
  disp = disp*mnA/mndauto;                          // нормируем вертикальную выдачу по каналу D
  dispp = disp +2;    	                            // задаём высоту точки в 2 пикселя
  }                                                 // если не AUTO, сразу попадаем сюда
  tft.drawLine(v,disp,v,dispp,TFT_RED);             // вывод на экран графика содержимого регистра (disp)
  }                                                 // если канал не A, сразу попадаем сюда
  if (c == 2){                                      // если текущий канал B
  if (bitRead(reg_IN, 5) == 0) {                    // проверяем пятый бит если 0 - AUTO
  disp = disp*mnB/mndauto;                          // нормируем вертикальную выдачу по каналу D
  dispp = disp +2;    	                            // задаём высоту точки в 2 пикселя 
  }                                                 // если не AUTO, сразу попадаем сюда
  tft.drawLine(v,disp,v,dispp,TFT_YELLOW);          // вывод на экран графика содержимого регистра (disp) 
  }                                                 // если канал не B, сразу попадаем сюда
  if (c == 1){                                      // если текущий канал C
  if (bitRead(reg_IN, 5) == 0) {                    // проверяем пятый бит если 0 - AUTO
  disp = disp*mnC/mndauto;                          // нормируем вертикальную выдачу по каналу D   
  dispp = disp +2;    	                            // задаём высоту точки в 2 пикселя  
  }                                                 // если не AUTO, сразу попадаем сюда
  tft.drawLine(v,disp,v,dispp,TFT_GREEN);           // вывод на экран графика содержимого регистра (disp) 
  }                                                 // если канал не C, сразу попадаем сюда
  if (c == 0){                                      // если текущий канал D
  if (bitRead(reg_IN, 5) == 0) {                    // проверяем пятый бит если 0 - AUTO
  disp = disp*mnd/mndauto;                          // нормируем вертикальную выдачу по каналу D
  dispp = disp +2;    	                            // задаём высоту точки в 2 пикселя  
  }                                                 // если не AUTO, сразу попадаем сюда
  tft.drawLine(v,disp,v,dispp,TFT_CYAN);            // вывод на экран графика содержимого регистра (disp) 
  }                                                 // если все каналы просмотрели, попадаем сюда 

  if (osc == 1){                 // если включён осциллограф
  if (count != 0) {                                 // если счётчик не равен нулю
  disp = disp*1.5 + 101;                            // переводим вертикальный масштаб в горизонтальный (360 / 240)
  dispp = dispp*1.5 + 101;                          // переводим вертикальный масштаб в горизонтальный (360 / 240)
  if (c == 3){                                      // если текущий канал A
  tft.drawLine(dispm,oscn,disp,oscn,TFT_RED);       // вывод на экран нуля текущего импульса
  tft.drawLine(disp,oscv,disp,oscn,TFT_RED);        // вывод на экран фронта первого импульса
  tft.drawLine(disp,oscv,dispp,oscv,TFT_RED);       // вывод на экран полочки первого импульса
  tft.drawLine(dispp,oscv,dispp,oscn,TFT_RED);      // вывод на экран спада первого импульса
  if (j == (count - 1)) {                           // если последнее измерение
  tft.drawLine(dispp,oscn,460,oscn,TFT_RED); }      // вывод на экран нулевой линии до конца
  } else                                            // если канал не A, сразу попадаем сюда  
  if (c == 2){                                      // если текущий канал B
  tft.drawLine(dispm,oscn,disp,oscn,TFT_YELLOW);    // вывод на экран нуля текущего импульса
  tft.drawLine(disp,oscv,disp,oscn,TFT_YELLOW);     // вывод на экран фронта первого импульса
  tft.drawLine(disp,oscv,dispp,oscv,TFT_YELLOW);    // вывод на экран полочки первого импульса
  tft.drawLine(dispp,oscv,dispp,oscn,TFT_YELLOW);   // вывод на экран спада первого импульса
  if (j == (count - 1)) { 			    // если последнее измерение
  tft.drawLine(dispp,oscn,460,oscn,TFT_YELLOW); }   // вывод на экран нулевой линии до конца
  } else                                            // если канал не B, сразу попадаем сюда   
  if (c == 1){                                      // если текущий канал C
  tft.drawLine(dispm,oscn,disp,oscn,TFT_GREEN);     // вывод на экран нуля текущего импульса
  tft.drawLine(disp,oscv,disp,oscn,TFT_GREEN);      // вывод на экран фронта первого импульса
  tft.drawLine(disp,oscv,dispp,oscv,TFT_GREEN);     // вывод на экран полочки первого импульса
  tft.drawLine(dispp,oscv,dispp,oscn,TFT_GREEN);    // вывод на экран спада первого импульса
  if (j == (count - 1)) { 			    // если последнее измерение
  tft.drawLine(dispp,oscn,460,oscn,TFT_GREEN); }    // вывод на экран нулевой линии до конца
  } else                                            // если канал не C, сразу попадаем сюда
  if (c == 0){                                      // если текущий канал D
  tft.drawLine(dispm,oscn,disp,oscn,TFT_CYAN);      // вывод на экран нуля текущего импульса
  tft.drawLine(disp,oscv,disp,oscn,TFT_CYAN);       // вывод на экран фронта первого импульса
  tft.drawLine(disp,oscv,dispp,oscv,TFT_CYAN);      // вывод на экран полочки первого импульса
  tft.drawLine(dispp,oscv,dispp,oscn,TFT_CYAN);     // вывод на экран спада первого импульса
  if (j == (count - 1)) { 			    // если последнее измерение
  tft.drawLine(dispp,oscn,460,oscn,TFT_CYAN); }     // вывод на экран нулевой линии до конца
  }                                                 // если все каналы просмотрели, попадаем сюда    
  dispm = dispp;                                    // запоминаем предыдущую конечную точку графика
  }                                                 // если счётчик равен нулю, сразу идём сюда
  }                                                 // если осциллограф не включён, сразу попадаем сюда
  j = j+2;                                          // переходим к следующей координате
  }                                                 // завершение очередного прохода обработки остальных импульсов  
  }                                                 // перебрали массив  

  if (reading == 0 ){                          // если не установлен процесс чтения всего массива
  if (bitRead(reg_IN, 5) == 0) {               // проверяем пятый бит если 0 - AUTO
  if (c  == 3) {                               // проверяем канал, если 3 
  v = v + 1; }                                 // переход графика на следующую позицию
  } else                                       // если c не 3, сразу попадаем сюда 
  {                                            // если не AUTO, сразу попадаем сюда
  v = v + 1;}                                  // переход графика на следующую позицию
  }                                            // если установлен процесс чтения всего массива
  if (v == 460){ (v = 100);                    // если дошли до конца экрана, устанвливаем счётчик столбцов в начало  
  tft.fillScreen(TFT_BLACK);                   // очистка экрана, цвет чёрный
  tft.setTextColor(TFT_YELLOW,TFT_BLACK); }    // жёлтый шрифт на чёрном фоне
  if (reading == 1 ){                          // если не установлен процесс чтения всего массива
  // knreadSD();                                  // обработка кнопок управления SD картой 
  knreadSD();  }                                // обработка кнопок управления SD картой ??? 
  }                                            // запвершение процесса void OutDisp() 
 
                  // Обработка нажатия кнопок и вывод на светодиодную индикацию.

  void impuls() {			       // Обработка кнопок
  
                          // проверка кнопоки 10 на нажатие

  if (zap == 1 ) {                             // Если установлен режим записи,
  read_kn();                                   // чтение кнопок 
  zapknt = bitRead(reg_kn2, 5);                // Читаем текущее состояние пина AUTO
  if (zapknt == 0 ) {                          // Если 0, смотрим, первое чтение, или нет
  if (zapknp == 1 ) {                          // Если 1, первое чтение, 
  if (reading == 0 ) {                         // если не режим чтения 
  pzap = p;                                    // запоминаем длительность импульса перед записью 
  p = 0;                                       // текущая длительность импульса = 1
  uzap = u;                                    // запоминаем коэффициент усиления перед записью 
  u = 0;                                       // текущий коэффициент усиления = 1
  zapisy = 1;                                  // устанавливаем флаг процесса записи на карту памяти
  bitSet(regout, 6);                           // запись единицы в 6 разряд 
  } } }
  if (qryzap == 1 ) {                          // Если есть запрос на карту памяти
  zapisy = 1;                                  // устанавливаем флаг процесса записи на карту памяти
  bitSet(regout, 6);                           // запись единицы в 6 разряд 
  qryzap = 0;                                 // сброс флага записи на карту памяти
  }                                           
  zapknp = zapknt;                             // записываем текущее состояние кнопки в предыдущее
  }                                            // Если не установлен режим записи, идём сюда
			            
                            // проверка кнопок 0 - 10 на нажатие

  read_kn();                                   // чтение кнопок 
  regkn1 = reg_kn1;                            // чтение кнопок управления исполнительным устройством
  regkn2 = reg_kn2;                            // чтение кнопок управления каналами

                     // проверка кнопок 0 - 5 на нажатие, формирование регистра regout

  regkn = regkn1 | 0b00000001;                 // маскировка ненужных битов
  regkn = ~regkn;                              // инвертируем

  if (zap == 1 ) {                             // Если установлен режим записи, 
  if (zapisy == 1 || fluzap == 1 ) {           // Если установлен процесс записи,  
  regkn = 0;                                   // обнуляем
  if (p == 0 ) {                               // Если установлен коэффициент 0, 
  bitSet(regkn, 1);                            // запись единицы в ind1 
  } else
  if (p == 1 ) {                               // Если установлен  коэффициент 1,
  bitSet(regkn, 2);                            // запись единицы в ind1 
  } else
  if (p == 2 ) {                               // Если установлен  коэффициент 2,, 
  bitSet(regkn, 3);                            // запись единицы в ind1 
  }
  if (u == 0 ) {                               // Если установлен коэффициент 0, 
  bitSet(regkn, 4);                            // запись единицы в ind1 
  } else
  if (u == 1 ) {                               // Если установлен  коэффициент 1,
  bitSet(regkn, 5);                            // запись единицы в ind1 
  } else
  if (u == 2 ) {                               // Если установлен  коэффициент 2,, 
  bitSet(regkn, 6);                            // запись единицы в ind1 
  }
  fluzap = 0;                                  // сброс флага коэффициента усиления перед записью
  } }                                          // Если не установлен режим записи, идём сюда

  if (regkn != 0) {                            // если есть нажатие кнопки
  if (bitRead(regkn, 1) == 1) {	               // проверяем бит 1 - если есть нажатие кнопки 0  
  bitClear(regm1, 0);                          // запись нуля в ind0 
  bitClear(reg_ind1, 4);                       // запись нуля в reg_ind1, 4
  bitSet(regm1, 1);                            // запись единицы в ind1 
  bitSet(reg_ind1, 5);                         // запись единицы в reg_ind1, 5
  bitSet(regm1, 2);                            // запись единицы в ind2 
  bitSet(reg_ind1, 6);                         // запись единицы в reg_ind1, 6
  bitSet(regout, 3);                           // запись единицы в A1T 
  bitSet(regout, 5);                           // запись единицы в A0T 
  p = 0;                                       // длительность пачки импульсов 4 импульса
  }                                            // если нет нажатия кнопки 0
  if (bitRead(regkn, 2) == 1) {                // проверяем бит 2 - если есть нажатие кнопки 1
  bitSet(regm1, 0);                            // запись единицы в ind0 
  bitSet(reg_ind1, 4);                         // запись единицы в reg_ind1, 4
  bitClear(regm1, 1);                          // запись нуля в ind1
  bitClear(reg_ind1, 5);                       // запись нуля в reg_ind1, 5
  bitSet(regm1, 2);                            // запись единицы в ind2 
  bitSet(reg_ind1, 6);                         // запись единицы в reg_ind1, 6
  bitSet(regout, 3);                           // запись единицы в A1T 
  bitClear(regout, 5);                         // запись нуля в A0T 
  p = 1;                                       // длительность пачки импульсов 8 импульсов
  }                                            // если нет нажатия кнопки 1
  if (bitRead(regkn, 3) == 1) {                // проверяем второй бит - если есть нажатие кнопки 2
  bitSet(regm1, 0);                            // запись единицы в ind0 
  bitSet(reg_ind1, 4);                         // запись единицы в reg_ind1, 4
  bitSet(regm1, 1);                            // запись единицы в ind1
  bitSet(reg_ind1, 5);                         // запись единицы в reg_ind1, 5
  bitClear(regm1, 2);                          // запись нуля в ind2 
  bitClear(reg_ind1, 6);                       // запись нуля в reg_ind1, 6
  bitClear(regout, 3);                         // запись нуля в A1T 
  bitSet(regout, 5);                           // запись единицы в A0T 
  p = 2;                                       // длительность пачки импульсов 16 импульсов
  }                                            // если нет нажатия кнопки 2
  if (bitRead(regkn, 4) == 1) {                // проверяем пятый бит - если есть нажатие кнопки 3
  bitClear(regm1, 5);                          // запись нуля в ind3 
  bitClear(reg_ind1, 7);                       // запись нуля в reg_ind1, 7
  bitSet(regm1, 6);                            // запись единицы в ind4
  bitSet(reg_ind2, 1);                         // запись единицы в reg_ind2, 1
  bitSet(regm1, 7);                            // запись единицы в ind5 
  bitSet(reg_ind2, 2);                         // запись единицы в reg_ind2, 2
  bitSet(regout, 1);                           // запись единицы в A1R 
  bitClear(regout, 2);                         // запись нуля в A0R 
  u = 0;                                       // текущий коэффициент усиления = 1
  }                                            // если нет нажатия кнопки 3
  if (bitRead(regkn, 5) == 1) {                // проверяем шестой бит - если есть нажатие кнопки 4
  bitSet(regm1, 5);                            // запись единицы в ind3 
  bitSet(reg_ind1, 7);                         // запись единицы в reg_ind1, 7
  bitClear(regm1, 6);                          // запись нуля в ind4
  bitClear(reg_ind2, 1);                       // запись нуля в reg_ind2, 1
  bitSet(regm1, 7);                            // запись единицы в ind5 
  bitSet(reg_ind2, 2);                         // запись единицы в reg_ind2, 2
  bitClear(regout, 1);                         // запись нуля в A1R 
  bitSet(regout, 2);                           // запись единицы в A0R
  u = 1;                                       // текущий коэффициент усиления = 6
  }                                            // если нет нажатия кнопки 4
  if (bitRead(regkn, 6) == 1) {                // проверяем седьмой бит - если есть нажатие кнопки 5
  bitSet(regm1, 5);                            // запись единицы в ind3 
  bitSet(reg_ind1, 7);                         // запись единицы в reg_ind1, 7
  bitSet(regm1, 6);                            // запись единицы в ind4
  bitSet(reg_ind2, 1);                         // запись единицы в reg_ind2, 1
  bitClear(regm1, 7);                          // запись нуля в ind5 
  bitClear(reg_ind2, 2);                       // запись нуля в reg_ind2, 2
  bitSet(regout, 1);                           // запись единицы в A1R 
  bitSet(regout, 2);                           // запись единицы в A0R 
  u = 2;                                       // текущий коэффициент усиления = 36
  }
                          // включение светодиодов индикации режима

  write_ind();                                 // запись индикации

  }                                            //  если нет нажатия кнопок 0 - 5, сразу идём сюда

  read_kn();                                   // чтение кнопок
  djmp = bitRead(reg_kn2, 0);                  // чтение переключателя DC
  bitWrite(regout,4,djmp);                     // запись состояния переключателя DC в DC

                           // проверка кнопоки 11 на нажатие

  read_kn();                                   // чтение кнопок
  oscknt = bitRead(reg_kn2, 6);                // читаем текущее состояние кнопки "Запись"
  if (oscknt == 0 ) {                          // если 0 - нажатие, смотрим, первое чтение, или нет
  if (oscknp == 1 ) {                          // если 1, первое чтение, 
  ekrpush =  millis();                         // читаем текущее машинное время нажатия кнопки Экран
  ekran = 1;                                   // установка флага нажатия кнопки Экран
  } else {                                     // если не первое чтение,
  ekrnow =  millis();                          // читаем текущее машинное время в мс 
  if (ekran && ekrnow - ekrpush >= 700) {      // если есть флаг нажатия и время нажатия больше 0,7 сек
  if (reading == 1 ){                          // если установлен процесс чтения всего массива
  screen = !screen;                            // инвертируем флаг режима чтения
  ekran = 0;                                   // сброс флага нажатия кнопки Экран
  } else {
  zap = !zap;                                  // инвертируем флаг режима записи
  ekran = 0;                                   // сброс флага нажатия кнопки Экран
  if (nocard == 1 ) {                          // если флаг отсутствия карты памяти 
  zap = 0;                                     // сбрасываем флаг режима записи
  tft.fillRect(0,156,100,7,TFT_RED);           // запись на экран красного квадрата   
  delay (1000);                                // задержка
  tft.fillRect(0,156,100,7,TFT_BLACK);         // запись на экран чёрного квадрата
  tft.drawLine(0,160,100,160,TFT_YELLOW);      // вывод на экран средней линии
  } else {
  if (zap == 1 ) {                             // если 1 
  findemaxkat(SD);                             // определяем имя последнего каталога
  numkat = maxkat;                             // текущее имя = имя последнего каталога
  findemaxfile(SD);                            // определяем имя последнего файла
  namefile = maxfile;                          // текущее имя = имя последнего файла
  ekran = 0;                                   // сброс флага нажатия кнопки Экран
  } } } } } } else {                           // если 1 - нажатия нет, смотрим, нет ли отпускания
  if (oscknp == 0 ) {                          // если 0, - отжатие кнопли Экран
  if (ekran && !reading ) {                    // если флаг нажатия есть, значит 1 сек не прошло и это осциллограф 
  osc = !osc;                                  // инвертируем флаг осциллографа
  if (osc == 0 ) {                             // если выключение осциллографа, 
  tft.drawLine(100,240,460,240,TFT_BLACK);     // стирание на экране нижней линии
  tft.fillRect(100,242,460,78,TFT_BLACK);      // запись на экран чёрного квадрата  
  }
  ekran = 0;                                   // сброс флага нажатия кнопки Экран
  } }
  if (reading == 1 ) {                         // если режим чтения
  osc = 0; }                                   // выключаем осциллограф
  } 
  oscknp = oscknt;                             // записываем текущее состояние кнопки в предыдущее
				
                            // проверка кнопок 6 - 10 на нажатие

  if (reading == 0 ) {                         // если не установлен процесс чтения всего массива
  read_kn();                                   // чтение кнопок
  regkn1 = reg_kn1;                            // чтение кнопок управления исполнительным устройством
  regkn2 = reg_kn2;                            // чтение кнопок управления каналами
  regkn = regkn2 | 0b11000001;                 // маскировка ненужных битов
  regkn = ~regkn;                              // инвертируем
  if (zap == 1 ) {                             // Если установлен режим записи, 
  regkn = 0x20;                                // устанавливаем режим Auto
  }
  if (regkn != 0) {                            // если есть нажатие кнопки
  
  reg_ind2 = reg_ind2 | 0b11111000;            // установка в 1 битов 3-7
  regm2 = 0xFF;                                // устанавливаем все единицы в regm2
  if (bitRead(regkn, 1) == 1) {                // проверяем первый бит - если есть нажатие кнопки 6
  bitClear(regm2, 1);                          // запись нуля в indA (L4)
  bitClear(reg_ind2, 3);                       // запись нуля в reg_ind2, 3
  c = 3;                                       // канал A
  }else	                                       // если нет нажатия кнопки 6
  if (bitRead(regkn, 2) == 1) {	               // проверяем второй бит - если есть нажатие кнопки 7
  bitClear(regm2, 2);                          // запись нуля в indB(L3)
  bitClear(reg_ind2, 4);                       // запись нуля в reg_ind2, 4
  c = 2;                                       // канал B
  }else                                        // если нет нажатия кнопки 7
  if (bitRead(regkn, 3) == 1) {                // проверяем третий бит - если есть нажатие кнопки 8
  bitClear(regm2, 3);                          // запись нуля в indC(L2) 
  bitClear(reg_ind2, 5);                       // запись нуля в reg_ind2, 5
  c = 1;                                       // канал C
  }else	                                       // если нет нажатия кнопки 8
  if (bitRead(regkn, 4) == 1) {	               // проверяем четвёртый бит - если есть нажатие кнопки 9
  bitClear(regm2, 4);                          // запись нуля в indA(L1)
  bitClear(reg_ind2, 6);                       // запись нуля в reg_ind2, 6
  c = 0;                                       // канал D
  }else	                                       // если нет нажатия кнопки 10
  if (bitRead(regkn, 5) == 1) {	               // проверяем пятый бит - если есть нажатие кнопки 10
  bitClear(regm2, 5);                          // запись нуля в indAUTO
  bitClear(reg_ind2, 7);                       // запись нуля в reg_ind2, 7
  reg_IN = 0xDF;                               // устанавливаем бит индикации канала AUTO
	}
                    // включение светодиодов индикации режима

  write_ind();                                 // запись индикации
  } }                                          // если нет нажатия кнопки, сразу идём сюда

                          // гашение светодиодов L1 - L4

  reg_ind1 = reg_ind1 | 0b00001111;            // установка в 1 битов 0-3
  write_ind();                                 // запись индикации

  if (zap == 1 ) {                             // Если установлен режим записи, 

               // проверка кнопоки 0 на нажатие - удаление одного файла из каталога
   
  read_kn();                                   // чтение кнопок
  delknt = bitRead(reg_kn1, 1);                // Читаем текущее состояние кнопоки 0 
  if (delknt == 0 ) {                          // Если 0 - нажатие, смотрим, первое чтение, или нет
  if (delknp == 1 ) {                          // Если 1, первое чтение, 
  delpush =  millis();                         // Читаем текущее машинное время нажатия кнопки 0
  delfl = 1;                                   // устанавливаем флаг нажатия
  } else {                                     // Если не первое чтение,
  delnow =  millis();                          // Читаем текущее машинное время в мс 
  if (delfl && delnow - delpush >= 500) {      // Если есть флаг нажатия и время нажатия больше 0,5 сек
  namefile = maxfile;                          // текущее имя = имя последнего файла
  String fildname = "/"+String(numkat)+"/"+String(namefile)+".txt";   
  deleteFile(SD, fildname.c_str());
  findemaxfile(SD);                            // определяем имя последнего файла
  namefile = maxfile;                          // текущее имя = имя последнего файла
  delfl = 0;                                   // сброс флага нажатия
  } } } else {                                 // если кнопку отжали
  if (delknp == 0 ) {                          // Если 0, отжатие 
  delfl = 0;                                   // сброс флага нажатия кнопки 0
  } } 
  delknp = delknt;                             // записываем текущее состояние кнопки в предыдущее
  
             // проверка кнопки 1 на нажатие - удаление всех файлов из текущего каталога карты памяти
  
  read_kn();                                   // чтение кнопок
  delfileknt = bitRead(reg_kn1 ,2);            // Читаем текущее состояние кнопки 1
  if (delfileknt == 0 ) {                      // Если 0 - нажатие, смотрим, первое чтение, или нет
  if (delfileknp == 1 ) {                      // Если 1, первое чтение, 
  delfilepush =  millis();                     // Читаем текущее машинное время нажатия кнопки 1
  delfilefl = 1;                               // устанавливаем флаг нажатия
  } else {                                     // Если не первое чтение,
  delfilenow =  millis();                      // Читаем текущее машинное время в мс 
  if (delfilefl && delfilenow - delfilepush >= 500) {   // Если есть флаг нажатия и время нажатия больше 0,5 сек
  deliteArrey(SD);
  findemaxfile(SD);                            // определяем имя последнего файла
  namefile = maxfile;                          // текущее имя = имя последнего файла
  delfilefl = 0;                               // сброс флага нажатия
  } } } else {                                 // если кнопку отжали
  if (delfileknp == 0 ) {                      // Если 0, отжатие 
  delfilefl = 0;                               // сброс флага нажатия кнопки 1
  } } 
  delfileknp = delfileknt;                     // записываем текущее состояние кнопки в предыдущее
                   
                 // проверка кнопки 2 на нажатие - удаление каталога 

  read_kn();                                   // чтение кнопок
  delkatknt = bitRead(reg_kn1, 3);             // Читаем текущее состояние кнопки 2
  if (delkatknt == 0 ) {                       // Если 0 - нажатие, смотрим, первое чтение, или нет
  if (delkatknp == 1 ) {                       // Если 1, первое чтение, 
  delkatpush =  millis();                      // Читаем текущее машинное время нажатия кнопки 2
  delkatfl = 1;                                // Установка флага нажатия кнопки 2
  } else {                                     // Если не первое чтение,
  delkatnow =  millis();                       // Читаем текущее машинное время в мс 
  if (delkatfl && delkatnow - delkatpush >= 500){   // Если есть флаг нажатия и время нажатия больше 0,5 сек
  if (numkat == maxkat && numkat > 0){         // Если каталог последний и не первый 
  String katnum = "/"+String(numkat);   
  removeDir(SD, katnum.c_str());               // удаляем maxkat
  findemaxkat(SD);                             // определяем имя последнего каталога
  numkat = maxkat;                             // текущее имя = имя последнего каталога
  findemaxfile(SD);                            // определяем имя последнего файла
  namefile = maxfile;                          // текущее имя = имя последнего файла
  delkatfl = 0; } } }                          // сброс флага нажатия кнопки 2
  } else {                                     // если кнопку отжали
  if (delkatknp == 0 ) {                       // Если 0, отжатие 
  delkatfl = 0;                                // сброс флага нажатия кнопки 3
  } } 
  delkatknp = delkatknt;                       // записываем текущее состояние кнопки в предыдущее

            // проверка кнопок 3 и 4 на нажатие - уменьшение предельного расстояния
  
  if (reading == 1 ) {                         // если режим чтения 
  read_kn();                                   // чтение кнопок
  mndecrknt = bitRead(reg_kn1,4) || bitRead(reg_kn1,5);   // Читаем текущее состояние кнопок 3 и 4
  if (mndecrknt == 0 ) {                       // Если 0 - нажатие, смотрим, первое чтение, или нет
  if (mndecrknp == 1 ) {                       // Если 1, первое чтение, 
  if (x > 0) {                                    // если расстояние не минимальное
  x = x - 1; }                                    // указываем предыдущее значение предельного расстояния
  } } 
  mndecrknp = mndecrknt;                          // записываем текущее состояние кнопки в предыдущее
 
           // проверка кнопок 4 и 5 на нажатие - увеличение предельного расстояния
  
  read_kn();                                   // чтение кнопок
  mnincrknt = bitRead(reg_kn1,5) || bitRead(reg_kn1,6);   // читаем текущее состояние кнопок 4 и 5
  if (mnincrknt == 0 ) {                       // если 0 - нажатие, смотрим, первое чтение, или нет
  if (mnincrknp == 1 ) {                       // если 1, первое чтение, 
  if (x < 6) {                                    // если значение предельного расстояния не максимальное
  x = x + 1; }                                    // указываем следующее значение предельного расстояния
  } } 
  mnincrknp = mnincrknt;                       // записываем текущее состояние кнопки в предыдущее
  }
                    
                  // проверка кнопок 3 и 5 на нажатие - создание нового каталога

  read_kn();                                   // чтение кнопок
  newkatknt = bitRead(reg_kn1,4) || bitRead(reg_kn1,6);   // читаем текущее состояние кнопок 3 и 5
  if (newkatknt == 0 ) {                       // если 0 - нажатие, смотрим, первое чтение, или нет
  if (newkatknp == 1 ) {                       // если 1, первое чтение, 
  newkatpush =  millis();                      // читаем текущее машинное время нажатия кнопки 5
  newkatfl = 1;                                // устанавливаем флаг нажатия
  } else {                                     // если не первое чтение,
  newkatnow =  millis();                       // читаем текущее машинное время в мс 
  if (newkatfl && newkatnow - newkatpush >= 500) {   // если есть флаг нажатия и время нажатия больше 0,5 сек
  if (numkat == maxkat){                       // если каталог последний и не первый 
  maxkat = maxkat +1;                          // устанавливаем следующий maxkat 
  numkat = maxkat;                             // текущее имя = имя последнего каталога
  String katnum = "/"+String(numkat);   
  createDir(SD, katnum.c_str());               // создаём следущий каталог 
  findemaxkat(SD);                             // определяем имя последнего каталога
  numkat = maxkat;                             // текущее имя = имя последнего каталога
  findemaxfile(SD);                            // определяем имя последнего файла
  namefile = maxfile;                          // текущее имя = имя последнего файла
  newkatfl = 0;                                // сброс флага нажатия
  } } } } else {                               // если кнопку отжали
  if (newkatknp == 0 ) {                       // если 1, первое чтение, 
  newkatfl = 0;                                // сброс флага нажатия кнопки 3
  } } 
  newkatknp = newkatknt;                       // записываем текущее состояние кнопки в предыдущее

        
                 // проверка кнопоки 5 на нажатие - перебор каталога вверх 

  read_kn();                                   // чтение кнопок
  incrknt = bitRead(reg_kn1, 6);               // читаем текущее состояние кнопки 5
  if (incrknt == 0 ) {                         // если 0 - нажатие, смотрим, первое чтение, или нет
  if (incrknp == 1 ) {                         // если 1, первое чтение, 
  incrpush =  millis();                        // читаем текущее машинное время нажатия кнопки 5
  incrfl = 1;                                  // установка флага нажатия кнопки 5
  } else {                                     // если не первое чтение,
  incrnow =  millis();                         // читаем текущее машинное время в мс 
  if (dispknt && !newkatfl && incrfl && incrnow - incrpush >= 500){   // если есть флаг нажатия и больше 0,5 сек
  if (numkat < maxkat){                        // если каталог не последний
  numkat = numkat + 1;                         // текущее имя = имя последнего каталога
  findemaxfile(SD);                            // определяем имя последнего файла
  namefile = maxfile;                          // текущее имя = имя последнего файла
  incrfl = 0;                                  // сброс флага нажатия кнопки 5
  } } } } else {                               // если кнопку отжали
  if (incrknp == 0 ) {                         // если 0, отжатие, 
  incrfl = 0;                                  // сброс флага нажатия кнопки 3
  } } 
  incrknp = incrknt;                           // записываем текущее состояние кнопки в предыдущее

                // проверка кнопоки 12 на нажатие: длительное - режим чтения карты памяти,

  read_kn();                                   // чтение кнопок
  dispknt = bitRead(reg_kn2, 7);               // читаем текущее состояние кнопки 12
  if (dispknt == 0 ) {                         // если 0 - нажатие, смотрим, первое чтение, или нет
  if (dispknp == 1 ) {                         // если 1, первое чтение, 
  if (autonom == 1 ) {                         // если 0 -автономный режим
  reading = 1;
   } else {                                    // если 1 - смртрим, - отпускание до истечения 500 мс?
  if (reading == 0 ) {                         // если 0 - нажатие, смотрим, первое чтение, или нет
  reading = 1;
  bitSet(reg_ind2, 7);                         // запись 1 в reg_ind2, 7 - выключение AUTO
  osc = 0;                                     // выключаем осциллограф
  tft.fillScreen(TFT_BLACK);                   // очистка экрана, цвет чёрный
  } else {                                     // если 1 - смртрим, - отпускание до истечения 500 мс?
  reading = 0;
  readAUTO = 0;                                // сброс флага чтения всех каналов
  readingA = 0;                                // сброс флага чтения канала A
  readingB = 0;                                // сброс флага чтения канала B
  readingC = 0;                                // сброс флага чтения канала C
  readingD = 0;                                // сброс флага чтения канала D
  g = maxfile ;
  bitClear(regm2, 5);                          // запись нуля в ind5 
  bitClear(reg_ind2, 7);                       // запись нуля в reg_ind2, 7 - включение FUTO
  p = 0;                                       // текущая длительность импульса = 4
  u = 0;                                       // текущий коэффициент усиления = 1
  c = 0;                                       // текущий канал = 1
  flagrec = 1;                                 // установка флага приёма данных от ISP
  flagrequ = 0;                                // сброс флага отправки на ISP
  flagsend = 0;
  } } } }
  dispknp = dispknt;                           // записываем текущее состояние кнопки в предыдущее

                    // проверка кнопоки 3 на нажатие - перебор каталога вниз 

  read_kn();                                   // чтение кнопок
  decrknt = bitRead(reg_kn1, 4);               // читаем текущее состояние кнопки 3
  if (decrknt == 0 ) {                         // если 0 - нажатие, смотрим, первое чтение, или нет
  if (decrknp == 1 ) {                         // если 1, первое чтение, 
  decrpush =  millis();                        // читаем текущее машинное время нажатия кнопки 3
  decrfl = 1;                                  // установка флага нажатия кнопки 3
  } else {                                     // если не первое чтение,
  decrnow =  millis();                         // читаем текущее машинное время в мс 
  if (dispknt  && !newkatfl && decrfl && decrnow - decrpush >= 500){   // если есть флаг нажатия и больше 0,5 сек
  if (numkat >0){                              // если каталог не первый
  numkat = numkat - 1;                         // устанавливаем предыдущий номер каталога
  findemaxfile(SD);                            // определяем имя последнего файла
  namefile = maxfile;                          // текущее имя = имя последнего файла
  decrfl = 0;                                  // сброс флага нажатия кнопки 3
  } } } } else {                               // если кнопку отжали
  if (decrknp == 0 ) {                         // если 1, первое чтение, 
  decrfl = 0;                                  // сброс флага нажатия кнопки 3
  } }
  decrknp = decrknt;                           // записываем текущее состояние кнопки в предыдущее
  }                                            // если режим запмси не установлен, сразу идём сюда
  }                                            // завершение impuls()

  void knreadSD(){    
  
                 // проверка кнопоки 6 на нажатие - чтение канала A (L4)

  read_kn();                                   // чтение кнопок
  readkntA = bitRead(reg_kn2, 1);              // читаем текущее состояние кнопки 6
  if (readkntA == 0 ) {                        // Если 0, смотрим, первое чтение, или нет
  if (readknpA == 1 ) {                        // Если 1, первое чтение, 
  readingA = !readingA; }                      // инвертируем флаг чтения канала A
  if (readingA == 0 ) {                        // если 0 - выключение
  g = maxfile;                                 // прерываем перебор файлов 
  } }   
  readknpA = readkntA;                         // записываем текущее состояние кнопки в предыдущее
   
                 // проверка кнопоки 7 на нажатие - чтение канала B (L3)

  readkntB = bitRead(reg_kn2, 2);              // читаем текущее состояние кнопки 7
  if (readkntB == 0 ) {                        // Если 0, смотрим, первое чтение, или нет
  if (readknpB == 1 ) {                        // Если 1, первое чтение, 
  readingB = !readingB; }                      // инвертируем флаг чтения канала B
  if (readingB == 0 ) {                        // если 0 - выключение
  g = maxfile  ;                               // прерываем перебор файлов 
  } }   
  readknpB = readkntB;                         // записываем текущее состояние кнопки в предыдущее
  
                 // проверка кнопоки 8 на нажатие - чтение канала C (L2)

  readkntC = bitRead(reg_kn2, 3);              // читаем текущее состояние кнопки 8
  if (readkntC == 0 ) {                        // Если 0, смотрим, первое чтение, или нет
  if (readknpC == 1 ) {                        // Если 1, первое чтение, 
  readingC = !readingC; }                      // инвертируем флаг чтенияканала C
  if (readingC == 0 ) {                        // если 0 - выключение
  g = maxfile  ;                               // прерываем перебор файлов 
  } }
  readknpC = readkntC;                         // записываем текущее состояние кнопки в предыдущее
  
                 // проверка кнопоки 9 на нажатие - чтение канала D (L1)

  readkntD = bitRead(reg_kn2, 4);              // читаем текущее состояние кнопки 9
  if (readkntD == 0 ) {                        // Если 0, смотрим, первое чтение, или нет
  if (readknpD == 1 ) {                        // Если 1, первое чтение, 
  readingD = !readingD; }                      // инвертируем флаг чтения канала D
  if (readingD == 0 ) {                        // если 0 - выключение
  g = maxfile  ;                               // прерываем перебор файлов 
  } }
  readknpD = readkntD;                         // записываем текущее состояние кнопки в предыдущее

                          // проверка кнопоки 10 на нажатие

  zapknt = bitRead(reg_kn2, 5);                // читаем текущее состояние кнопки 10
  if (zapknt == 0 ) {                          // Если 0, смотрим, первое чтение, или нет
  if (zapknp == 1 ) {                          // Если 1, первое чтение, 
  readAUTO = !readAUTO; }                      // инвертируем флаг чтения всех каналов
  if (readAUTO == 0 ) {                        // если 0 - выключение
  bitSet(reg_ind2, 7);                         // запись 1 в reg_ind2, 7 - выключение AUTO
  g = maxfile  ;                               // прерываем перебор файлов 
  } }
  zapknp = zapknt;                             // записываем текущее состояние кнопки в предыдущее
  } 

                   // Функция удаления всех файлов в каталоге

  void deliteArrey(fs::FS &fs){    

  String katnum = "/"+String(numkat);   
  File root = fs.open(katnum.c_str());
  while (true) {                               // пока есть
  File entry = root.openNextFile();            // открываем следующий файл
  if (! entry) {                               // если файлов больше нет
  break;                                       // уходим
  } else {                                     // если есть файлы  
  String fildel = "/" + String(numkat)+ "/" + entry.name();   
  if(fs.remove(fildel.c_str())){
  // Serial.println("File deleted");
  } else {
  // Serial.println("Delete failed");
  }
  } } 
  root.close();                                // закрываем последний каталог
  }                               

                   // Функция определения максимального имени каталога на карте памяти

  void findemaxkat(fs::FS &fs) {

  maxkat = 0;                                  // записываем 0 в maxkat 
  File root = fs.open("/");
  File entry = root.openNextFile();
  if (! entry) {                               // файлов нет
    if(fs.mkdir("/0")){
        // Serial.println("Dir /0 created");
    } else {
        // Serial.println("mkdir /0 failed");
    }
  }                                            // если есть файлы
  root.rewindDirectory();                      // уходим на первый файл
  while (true) {                               // пока есть
  File entry = root.openNextFile();            // открываем следующий файл
  if (! entry) {                               // если файлов больше нет
  break;                                       // уходим
  }                                            // если есть файлы  
  if (entry.isDirectory()) {                   // если текущий файл каталог
  numkat = atoi(entry.name());                 // конвертируем номер каталога в int,
  maxkat = max(maxkat,numkat);                 // находим максимальный номер каталога
  } } 
  // Serial.print("maxkat: ");
  // Serial.println(maxkat);
  root.close();                                // закрываем последний каталог
  }
                   // Функция определения максимального имени файла в каталоге на карте памяти

  void findemaxfile(fs::FS &fs) {
                          
  maxfile = 0;                                 // записываем 0 в maxfile 
  kolfile = 0;                                 // количество файлов 
  String katnum = "/"+String(numkat);   
  File root = fs.open(katnum.c_str());
  // Serial.printf("open directoryf file: %s\n", katnum.c_str());
  root.rewindDirectory();                      // уходим на первый файл
  while (true) {                               // пока есть
  File entry = root.openNextFile();            // открываем следующий файл
  if (! entry) {                               // если файлов больше нет
  break;                                       // уходим
  }  
  namefile = atoi(entry.name());               // конвертируем номер файла в int,     
  maxfile = max(maxfile,namefile);             // находим максимальный номер файла 
  kolfile = kolfile +1;                        // количество файлов 
  }
  if (kolfile == 0) {                          // если файлов больше нет
  numzap = 0;
  maxfile = 0;                                 // записываем 0 в maxfile 
  } else {
  numzap = maxfile +1;
  } 
  // Serial.print("maxfile: ");
  // Serial.println(maxfile);
  root.close();                                // закрываем последний каталог
  }

  void findkanal() {
  
         // Выясняем, какой канал текущий и заносим его в reg_IN

  if (bitRead(regm2, 5) == 0)      // проверяем пятый бит 0 - AUTO, 1 - SEPAR
  {                                // Если 0 - AUTO, читаем все пины
  if (flagn == 0 ) {               // Если 0, идём читать канал, иначе - уходим 
  if (k == 0) {                    // Если k = 0, - PinD 
  reg_IN = 0xCF;                   // устанавливаем бит канала D
  IND_BIT = 0;                     // Устанавливаем бит индикации канала D
  flagn = 1;                       // Устанавливаем flagn = 1. Пин определён
  c = 0;                           // запоминаем текущий канал
  k = 1;                           // Устанавливаем следующий канал
  } else                           // Если k не 0, идём дальше
  if (k == 1) {                    // Если k = 1, PinC
  reg_IN = 0xD7;                   // устанавливаем регистр канала C
  IND_BIT = 1;                     // Устанавливаем бит индикации канала C
  flagn = 1;                       // Устанавливаем flagn = 1. Пин прочитан
  c = 1;                           // запоминаем текущий канал
  k = 2;                           // Устанавливаем следующий канал
  } else                           // Если k не 1, идём дальше 
  if (k == 2) {                    // Если k = 2, PinB
  reg_IN = 0xDB;                   // устанавливаем регистр канала B
  IND_BIT = 2;                     // Устанавливаем бит индикации канала B
  flagn = 1;                       // Устанавливаем flagn = 1. Пин прочитан
  c = 2;                           // запоминаем текущий канал
  k = 3;                           // Устанавливаем следующий канал
  } else                           // Если k не 2, идём дальше 
  if (k == 3) {                    // Если k = 3, PinA
  reg_IN = 0xDD;                   // устанавливаем регистр канала A
  IND_BIT = 3;                     // Устанавливаем бит индикации канала A
  flagn = 1;                       // Устанавливаем flagn = 1. Пин прочитан
  c = 3;                           // запоминаем текущий канал
  k = 0;                           // Устанавливаем канал
  } }                              // flagn =1. Пин уже прочитан, уходим 

  } else                           // Значит, пятый бит = 1 - SEPAR, идём читать
  if (bitRead(regm2, 1) == 0) {    // Если первый бит = 0
  reg_IN = 0xFD;                   // устанавливаем регистр канала индикации
  IND_BIT = 3;                     // Устанавливаем бит индикации канала A
  c = 3;                           // запоминаем текущий канал
  } else                           // Если нет, идём дальше
  if (bitRead(regm2, 2) == 0) {    // Если второй бит = 0
  reg_IN = 0xFB;                   // устанавливаем регистр канала индикации
  IND_BIT = 2;                     // Устанавливаем бит индикации канала B
  c = 2;                           // запоминаем текущий канал
  }else                            // Если нет, идём дальше
  if (bitRead(regm2, 3) == 0) {    // Если третий бит = 0
  reg_IN = 0xF7;                   // устанавливаем регистр канала индикации
  IND_BIT = 1;                     // Устанавливаем бит индикации канала C
  c = 1;                           // запоминаем текущий канал
  }else                            // Если нет, идём дальше
  if (bitRead(regm2, 4) == 0) {    // Если четвёртый бит = 0
  reg_IN = 0xEF;                   // устанавливаем регистр канала индикации
  IND_BIT = 0;                     // Устанавливаем бит индикации канала D
  c = 0;                           // запоминаем текущий канал
  } 
  flagn = 0;                       // сброс флага прочитанного канала
  }                                

   void usildef() {      // Установка начальных значений 

  if (bitRead(regm1,0) == 0) {     // если 4 имп
  p = 0;
  } else                           // если нет, идём дальше
  if (bitRead(regm1,1) == 0) {     // если 8 имп
  p = 1;
  } else                           // если нет, идём дальше
  if (bitRead(regm1,2) == 0) {     // если 16 имп
  p = 2;
  } 
  if (bitRead(regm1,5) == 0) {     // если х1
  u = 0;
  } else                           // если нет, идём дальше
  if (bitRead(regm1,6) == 0) {     // если х6
  u = 1;
  } else                           // если нет, идём дальше
  if (bitRead(regm1,7) == 0) {     // если х36
  u = 2;
  } }

  void write_ind() {                               // запись индикации
  
  digitalWrite(WRO_Pin, LOW);                      // установка нуля в WRO_Pin
  shiftOut(DO_Pin, SCO_Pin, MSBFIRST, reg_ind2);   // занесение информации в сдвигающий регистр 
  shiftOut(DO_Pin, SCO_Pin, MSBFIRST, reg_ind1);   // занесение информации в сдвигающий регистр 
  digitalWrite(WRO_Pin, HIGH);                     // установка единицы в WRO_Pin, запись в выходной регистр
  }

  void read_kn() {                      // чтение кнопок
  
  digitalWrite(LC_Pin, LOW);                       // установка нуля в LC_Pin
  digitalWrite(SP_Pin, LOW);                       // установка режима записи в сдвигающий регистр
  delayMicroseconds(2);                            // удержание в течение 2 мксек
  digitalWrite(LC_Pin, HIGH);                      // занесение информации в первый и в сдвигающий регистры
  delayMicroseconds(2);                            // удержание в течение 2 мксек
  digitalWrite(SP_Pin, HIGH);                      // установка режима сдвига
  digitalWrite(LC_Pin, LOW);                       // установка нуля в LC_Pin
  reg_kn1 = shiftIn(DI_Pin, SCI_Pin, LSBFIRST);    // запись первого байта
  reg_kn2 = shiftIn(DI_Pin, SCI_Pin, LSBFIRST);    // запись второго байта
  }

  /*           7       6       5       4       3       2       1       0    

  R<- DD1     SA3      S0      S1      S2      S3      S4      S5      1  <-    
   - - - - > - - - > - - - > - - - > - - - > - - - > - - - > - - - > - - - -^
  ^<- DD2     SA1      S6      S7      S8      S9     S10     S11     S12  

   reg_kn1     1       S5      S4      S3      S2      S1      S0     SA3 <- LSBFIRST 1
               1      х36      х6      х1     16 имп  8 имп   4 имп  СРЕДА          

   reg_kn2    S12     S11     S10      S9      S8      S7      S6     SA1 <- LSBFIRST 2
             ЧТЕНИЕ ЗАПИСЬ    АВТО     L1      L2      L3      L4    12/24               

   reg_ind1   x1      16       8        4      L4I     L3I     L2I    L1I -> MSBFIRST 2 
               0       1       1        0       1       1       1      1        0x6F          
 
   reg_ind2   AUTO    L1      L2       L3      L4      x16      x8      X  -> MSBFIRST 1 
               1       1       1        1       0       1       1       1       0xF7         

  R-> DD3      x1      16       8       4     L4I     L3I     L2I     L1I ->
 - - - - - < - - - < - - - < - - - < - - - < - - - < - - - < - - - < - - - -
 ->   DD4     AUTO     L1      L2      L3      L4     x16      x8      X  


    regm1     X36      X6      X1   12/24V     -    16 имп   8 имп   4 имп                          
    
    regm2      -       -      АВТО     D       C       B       A       -       

    reg_IN     -       -      АВТО     D       C       B       A       -   

    regkn1    х36     х6      х1       -    12/24    16 имп  8 имп   4 имп
               1      х36      х6      х1     16 имп  8 имп   4 имп  СРЕДА       

    regkn2   ЭКРАН     -      АВТО     D       C       B       A     СРЕДА 
             ЧТЕНИЕ ЗАПИСЬ    АВТО     L1      L2      L3      L4    12/24  

       -        -       -       -      L1       L2      L3     L4       -        

       -        -       -       -     КАН 4   КАН 3    КАН 2   КАН 1    -          

     regout     -    zapisy    A0T     DC      A1T     A0R     A1R      -                           
	
                               DF      EF      F7      FB      FD                   
                               
                                       CF      D7      DB      DD                  


     regch      -     pusk      -       -       -       -       -       -



     regkn    0x80    0x40    0x20    0x10    0x08     0x04    0x02    0x01      
  */                                        



